import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class AlertTest extends MIDlet implements CommandListener {
   private Display display;
   private Command exit;
   private Alert[] alerts;
   private List alertList;

   /* 𿡼   Alert Ʈ ŸƲ */
   private static final String[] alertTitles = {
      "Info 3",
      "Info Modal",
      "Warning 3",
      "Warning Modal",
      "Error 3",
      "Error Modal",
      "Alarm 3",
      "Alarm Modal",
      "Confirmation 3",
      "Confirmation Modal"
   };

   /* 𿡼   Alert Ʈ Ÿ */
   private static final AlertType[] alertTypes = {
      AlertType.INFO,
      AlertType.INFO,
      AlertType.WARNING,
      AlertType.WARNING,
      AlertType.ERROR,
      AlertType.ERROR,
      AlertType.ALARM,
      AlertType.ALARM,
      AlertType.CONFIRMATION,
      AlertType.CONFIRMATION,
   };

   public AlertTest() {
      //  ÷̸ ´.
      display = Display.getDisplay(this);

      // Command Ʈ Ÿ԰ 켱 Ͽ  Ʈ Ѵ.
      exit = new Command("Exit", Command.EXIT, 0);
   }

   /* startApp() : JAM MIDlet   ȣѴ. */
   public void startApp() {
      // alertTitles.length  Alert Ʈ  迭 Ѵ.
      alerts = new Alert[alertTitles.length];
      for(int i=0;i<alertTitles.length;i++) {
         //  List Ʈ Ѵ.
         // Alert(String title, String alertText, Image alertImage, AlertType alertType)
         alerts[i] = new Alert("Alert: ["+alertTitles[i]+"]", alertTitles[i], null, alertTypes[i]);

         alerts[i].setTimeout(3000);  // Default timeout: 2000msec
         if(i % 2 == 1) {
            alerts[i].setTimeout(Alert.FOREVER);   // Alert.FOREVER: -2
         }
/*
         //  ׽Ʈ  α
         System.out.println("Alert: ["
                                     + "], ["+alerts[i].getDefaultTimeout()
                                     +"], ["+alerts[i].getString()
                                     + "], ["+alerts[i].getTimeout()
                                     + "], ["+alerts[i].getType() );
*/
         // Alert Ʈ Command ߰  .
      }

      // Alert  Ʈ ִ List Ʈ Ѵ.
      // List Choice ϹǷ, List.IMPLICIT Choice.IMPLICIT .
      // List(String title, int listType, String[] stringElements, Image[] imageElements)
      alertList = new List("Alert Demo:", List.IMPLICIT, alertTitles, null);

      // List Ʈ ɰ ̺Ʈ ڵ鷯 Ѵ.
      alertList.addCommand(exit);
      alertList.setCommandListener(this);

      // Alert  Ʈ ִ List Ʈ ̵ Ѵ
      display.setCurrent(alertList);
   }

   /* MIDlet Ͻ ų   ȣѴ.*/
   public void pauseApp() {
   }

   /* MIDlet  ų  ȣѴ */
   public void destroyApp (boolean unconditional) {
   }

   /*
   CommandListener ̽ commandAction(...) ޼ҵ带 Ѵ.
   Ŀ ̺Ʈ  ׼ óϴ κμ
   "Exit"  õǾ , destroyApp() ޼ҵ带 ȣѴ.
   */
   public void commandAction(Command cmd, Displayable s) {
      if(cmd == exit) {
         destroyApp(false);
         notifyDestroyed();
      } else if(s == alertList) {
         // List Ʈ õ ׸ Alert  شϴ
         // Alert Ʈ  ũ Ѵ.
         int index = alertList.getSelectedIndex();
         display.setCurrent(alerts[index]);
      }
   }
}
