import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class CanvasTest extends MIDlet implements CommandListener {
   private Command exit;

   class PlayGround extends Canvas {
      int x, y;

      public PlayGround() {
         x = getWidth() / 2;
         y = getHeight() / 2;
      }

      public void paint(Graphics g) {
         // Ͼ(0xffffff)  .
         g.setColor(0xffffff);
         g.fillRect(0, 0, getWidth(), getHeight());

         // (0x000000) 簢 ׸.
         g.setColor(0x000000);
         g.fillRect(x-3, y-3 , 10 ,10);
      }

      public void keyPressed(int keycode) {
         switch(getGameAction(keycode)) {
            case LEFT:  x -= 3; break;
            case RIGHT: x += 3; break;
            case UP:    y -= 3; break;
            case DOWN:  y += 3; break;
         }
         repaint();
      }
   }

   public CanvasTest() {
      // Command Ʈ Ÿ԰ 켱 Ͽ  Ʈ Ѵ.
      exit = new Command("EXIT", Command.EXIT, 1);
   }

   /* startApp() : JAM MIDlet   ȣѴ. */
   public void startApp() {
      PlayGround ground = new PlayGround();

      // PlayGround Ʈ exit  ߰ϰ, ̺Ʈ ڵ鷯 Ѵ.
      ground.addCommand(exit);
      ground.setCommandListener(this);

      //  ÷̸  ʱ ũ Ʈ ̵ Ѵ.
      Display display = Display.getDisplay(this);
      display.setCurrent(ground);
   }

   /* MIDlet Ͻ ų   ȣѴ.*/
   public void pauseApp() {
   }

   /* MIDlet  ų  ȣѴ */
   public void destroyApp (boolean unconditional) {
   }

   /*
   CommandListener ̽ commandAction(...) ޼ҵ带 Ѵ.
   Ŀ ̺Ʈ  ׼ óϴ κμ
   "Exit"  õǾ , destroyApp() ޼ҵ带 ȣѴ.
   */
   public void commandAction(Command cmd, Displayable s) {
      if(cmd ==exit) {
         destroyApp(true);
         notifyDestroyed();
      }
   }
}
