/**
 * ExceptionListenerTimerExample.java
 *
 * Timer Ŭ, TimerTask Ŭ ׹° 
 */

// ̺귯 ߰
import javax.microedition.midlet.*;
import java.util.*;
import java.io.*;

/**
 *  TimerTask Exception ߻Ͽ  
 * ExceptionListener Ͽ Exception ó
 */
public class ExceptionListenerTimerExample extends MIDlet 
{
 /**
  * MIDlet  Լ
  */
 protected void startApp() 
 {
  try 
  {
   // Timer 
   Timer t = new Timer();
   // FirstTimerTask 
   FirstTimerTask firstTask = new FirstTimerTask("FirstTimerTask");
   // FirstTimerTask ٸ , 1   1  ٸ
   // "fixed Delay" ۾ ٸ  
   // t.schedule(firstTask, 1000, 1000);
   // "fixed rate" ۾ ٸ  
   t.scheduleAtFixedRate(firstTask , 1000, 1000);
   // ExceptionThrowTask 
   ExceptionThrowTask exceptionTask = new ExceptionThrowTask(new  ExceptionLogger());
   // ExceptionThrowTask ٸ , 5 Ŀ 1  ٸ 
   t.schedule(exceptionTask, 5000, 1000);


   Thread.currentThread().sleep(12000);
  }
  catch (Exception e) 
  {
   e.printStackTrace();
  }
 }
 
 public void pauseApp() 
 { 
 }

 public void destroyApp(boolean unconditional) 
 {
 }
}

/**
 * First TimerTask
 * ۾ ó ð  ϴ TimerTask
 */
class FirstTimerTask extends TimerTask 
{
 private String name;
 
 //  ޼ҵ
 public FirstTimerTask(String name)
 {            
  //  ۾ ̸ 
  this.name = name; 
 }
 
 // ۾  Լ
 public void run() 
 {
  // ۾  ð 
  System.out.println(name + " run at " + getCurrentTime());
 }

 //  ý ð .
 public String getCurrentTime()
 {
 	Calendar calendar;
	calendar = Calendar.getInstance();
	return ("" + calendar.get(Calendar.YEAR) + " year " 
               + calendar.get(Calendar.MONTH) + " month "
               + calendar.get(Calendar.DAY_OF_MONTH) + " day "
               + calendar.get(Calendar.HOUR) + " hour "
               + calendar.get(Calendar.MINUTE) + " minute "
               + calendar.get(Calendar.SECOND) + " second ");
 }
}

interface ExceptionListener 
{ 
 public void exceptionOccurred(Throwable t);
}


class ExceptionLogger implements ExceptionListener 
{
 public void exceptionOccurred( Throwable t) 
 {
  System.err.println("Exception on Timer thread!");
  t.printStackTrace();
 }
}

/**
 * ExceptionThrowTask Ŭ
 * ExceptionListener Exception ó
 */
class ExceptionThrowTask extends TimerTask 
{
 ExceptionListener el;
 public ExceptionThrowTask(ExceptionListener  el) 
 {
  this.el = el;
 }

 public void run() 
 {
  try 
  {
   throw new Error("ExceptionThrowTask");
  }
  catch (Throwable t) 
  {
   cancel();
   el.exceptionOccurred(t);
  }
 }
}

