/**
 * LongTimerTaskExample.java
 *
 * Timer Ŭ, TimerTask Ŭ ι° 
 */

// ̺귯 ߰
import javax.microedition.midlet.*;
import java.util.*;
import java.io.*;

/**
 *  TimerTask  ð ó ɶ 
 */
public class LongTimerTaskExample extends MIDlet 
{
 /**
  * MIDlet  Լ
  */
 protected void startApp() 
 {
  try 
  {
   // Timer 
   Timer t = new Timer();
   // FirstTimerTask 
   FirstTimerTask firstTask = new FirstTimerTask("FirstTimerTask");
   // FirstTimerTask ٸ , 1   1  ٸ
   // "fixed Delay" ۾ ٸ  
   // t.schedule(firstTask, 1000, 1000);
   // "fixed rate" ۾ ٸ  
   t.scheduleAtFixedRate(firstTask , 1000, 1000);
   // LongTimeTimerTask 
   LongTimeTimerTask longTask = new LongTimeTimerTask("LongTimeTimerTask");
   // LongTimeTimerTask ٸ , 3 Ŀ ۾  
   t.schedule(longTask, 3000);

   Thread.currentThread().sleep(12000);
  }
  catch (Exception e) 
  {
   e.printStackTrace();
  }
 }
 
 public void pauseApp() 
 { 
 }

 public void destroyApp(boolean unconditional) 
 {
 }
}

/**
 * First TimerTask
 * ۾ ó ð  ϴ TimerTask
 */
class FirstTimerTask extends TimerTask 
{
 private String name;
 
 //  ޼ҵ
 public FirstTimerTask(String name)
 {            
  //  ۾ ̸ 
  this.name = name; 
 }
 
 // ۾  Լ
 public void run() 
 {
  // ۾  ð 
  System.out.println(name + " run at " + getCurrentTime());
 }

 //  ý ð .
 public String getCurrentTime()
 {
 	Calendar calendar;
	calendar = Calendar.getInstance();
	return ("" + calendar.get(Calendar.YEAR) + " year " 
               + calendar.get(Calendar.MONTH) + " month "
               + calendar.get(Calendar.DAY_OF_MONTH) + " day "
               + calendar.get(Calendar.HOUR) + " hour "
               + calendar.get(Calendar.MINUTE) + " minute "
               + calendar.get(Calendar.SECOND) + " second ");
 }
}

/**
 * LongTimeTimerTask
 *  ð ۾ ó ϴ TimerTask
 */
class LongTimeTimerTask extends TimerTask 
{
 private String name;

 //  ޼ҵ
 public LongTimeTimerTask(String name)
 {            
  //  ۾ ̸ 
  this.name = name; 
 }

 public void run() 
 {
  try
  {
   // 6  sleep Ѵ.
   Thread.currentThread().sleep(6000);
   // ۾ ó Ϸ ð 
   System.out.println(name + " run at " + getCurrentTime());
  }
  catch (InterruptedException ie) 
  {
  }
 }

 //  ý ð .
 public String getCurrentTime()
 {
 	Calendar calendar;
	calendar = Calendar.getInstance();
	return ("" + calendar.get(Calendar.YEAR) + " year " 
               + calendar.get(Calendar.MONTH) + " month "
               + calendar.get(Calendar.DAY_OF_MONTH) + " day "
               + calendar.get(Calendar.HOUR) + " hour "
               + calendar.get(Calendar.MINUTE) + " minute "
               + calendar.get(Calendar.SECOND) + " second ");
 }
}
