REM MIDP APPLICATION BUILDER

REM The application specific information
SET MAINCLASS=TimerDemo

REM The target path
SET JAVA_HOME=d:\java\jdk1.3
SET SRCDIR=src
SET CLASSDIR=classes
SET VERIFIED_CLASSDIR=output
SET MIDP_HOME=d:\java\midp-fcs
SET MIDPCLASSDIR=%MIDP_HOME%\classes

REM compile
MKDIR %CLASSDIR%
%JAVA_HOME%\bin\javac -bootclasspath %MIDPCLASSDIR% -d %CLASSDIR% %SRCDIR%\*.java

REM preverify
%MIDP_HOME%\bin\preverify -classpath %MIDPCLASSDIR% -d %VERIFIED_CLASSDIR% %CLASSDIR%

REM create application
SET SCREEN_DEPTH=8
%MIDP_HOME%\bin\midp -classpath %VERIFIED_CLASSDIR% %MAINCLASS%


