/**
 * Server α׷ J2ME CLDC/MIDP   
 * StreamConnection û ޾  Ʈ  α׷
 */

import java.io.*;
import java.net.*;

public class StreamConnectionServer implements Runnable
{
 private ServerSocket server = null;  // ServerSocket ü
 private Socket client = null;        // ClientSocket ü
 private DataInputStream in = null;   // Input Stream
 private DataOutputStream out = null; // Output Stream

 private boolean isListen = true;	   // Server Socket ȿ Ѱ?
 private final static int port = 9000; // Server Socket Port

 public StreamConnectionServer()
 {
  try
  {
   // Server Socket 
   server = new ServerSocket(port);
			
   while(isListen){
    System.out.println(" ٸ ֽϴ.");
    client = server.accept();
	System.out.println("Ŭ̾Ʈ  Ͽϴ.");
    
	// Client  ...
	Thread thread = new Thread(this);
	thread.start();
   }
  }
  catch (IOException e) 
  {
   System.err.println("Exception caught:" + e);
  }
  finally 
  {
   try { 
    if (server != null) server.close();
   }catch (Exception e) {}
  }
 }	
 
 public void run()
 {
   connect();
 }

 public void connect()
 {
  try
  {
    // Input Stream 
    in = new DataInputStream(client.getInputStream());
    // Client  ޼ 
	String input = in.readUTF();
    // Output ޼(Reverse String) 
    String output = (new StringBuffer(input)).reverse().toString();
    // Output Stream 
    out = new DataOutputStream(client.getOutputStream());
    // Client  ޼ 
    out.writeUTF(output);
    out.flush();
  } 
  catch (IOException e) 
  {
   System.err.println("Exception caught:" + e);
  }
  finally 
  {
   try { 
    if (client != null) client.close();
    if (in != null) out.close();			
    if (out != null) out.close();
   }catch (Exception e) {}
  }
 }

 public static void main(String[] args){
  new StreamConnectionServer();
 }
}