import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

import javax.microedition.io.*;

import java.io.*;

public class HttpTest extends IApplication implements ComponentListener {
	public void start() {
		Panel p = new Panel();
		url = new TextBox("http://uni.himitsukichi.com/iap/sample/HttpTest.html", 20, 1, TextBox.DISPLAY_ANY);
		p.add(url);
		req = new TextBox(null, 20, 1, TextBox.DISPLAY_ANY);
		p.add(req);
		body = new TextBox(null, 20, 8, TextBox.DISPLAY_ANY);
		p.add(body);
		body.setEditable(false);
		Display.setCurrent(p);
		
		p.setComponentListener(this);
	}
	TextBox url;
	TextBox req;
	TextBox body;
	public void componentAction(Component src, int type, int param) {
		if (src == url || src == req) {
			url.setEditable(false);
			req.setEditable(false);
			String r = req.getText();
			String res = null;
			if (r.length() == 0)
				res = httpget(url.getText());
			else
				res = httppost(url.getText(), r);
			if (res == null)
				res = "[null]";
			body.setText(res);
			url.setEditable(true);
			req.setEditable(true);
		}
	}
	String httpget(String url) {
		return httppost(url, null);
	}
	String httppost(String url, String s) {
		String res = null;
		try {
			HttpConnection conn = (HttpConnection)Connector.open(url, Connector.READ_WRITE, true);

			conn.setRequestMethod(s != null ? HttpConnection.POST : HttpConnection.GET);
			conn.setRequestProperty("Content-Type", "text/plain");
			
			if (s != null) {
				OutputStream out = conn.openOutputStream();
				byte[] b = null;
				try {
					b = s.getBytes("SJIS");
				} catch (IOException e) {
					b = s.getBytes();
				}
				out.write(b);
				out.close();
			}
			conn.connect();
			InputStream in = conn.openInputStream();
			if (in == null)
				throw new IOException();
			
			System.out.println(conn.getDate());
			System.out.println(conn.getType());
			System.out.println(conn.getLength());
			System.out.println(conn.getResponseCode());
			System.out.println(conn.getResponseMessage());
			
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			byte[] b = new byte[0x1000];
			for (;;) {
				int len = in.read(b);
				if (len < 0)
					break;
				baos.write(b, 0, len);
			}
			try {
				res = new String(baos.toByteArray(), "SJIS");
			} catch (IOException e) {
				res = new String(baos.toByteArray());
			}
			
			in.close();
			conn.close();
		} catch (Exception e) {
			System.out.println(e);
		}
		return res;
	}
}
