/*
 *  DateFieldTest.java
 *
 *  Monday, June 19, 2000
 *
 *   Copyright 2000 Motorola, Inc.  All Rights Reserved.
 *  This notice does not imply publication.
 */

package com.mot.j2me.midlets.tests;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * DateFieldTest demonstrates using the DateField component
 *
 * @see MIDlet
 */
public class DateFieldTest extends MIDlet {

    /**
     * The main screen
     */
    private Form mainScreen;

    /**
     * Reference to the Display
     */
    private Display myDisplay;

    /**
     * Create the DateFieldTest
     */
    DateFieldTest() {

        myDisplay = Display.getDisplay(this);
        mainScreen = new Form("Date Field Test");

        DateField df1 = new DateField(DateField.DATE);
        DateField df2 = new DateField(DateField.TIME);
        mainScreen.append(df1);
        mainScreen.append(df2);
    }

    /**
     * Starts the MIDlet
     */
    public void startApp() throws MIDletStateChangeException {

        myDisplay.setCurrent(mainScreen);
    }

    /**
     * Stop the MIDlet
     */
    public void pauseApp() {
    }

    /**
     * Called by the framework before the application is unloaded
     */
    public void destroyApp(boolean unconditional) {
    }
}