import com.xce.util.Debug;
import com.xce.lcdui.*;
import com.skt.m.*;
import java.io.IOException;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

class AniCanvas extends Canvas implements Runnable, CommandListener {
    Display display;
    AniMIDlet midlet;	
	
	Command exitCmd = new Command("", Command.EXIT, 1);

	long oldTime;
	String time = "0";
	boolean visible;
    Image imgs[] = new Image[14];
    int index;
	boolean loaded = false;
	
	public static final int MAX_IMG = 6;
	
    public AniCanvas(AniMIDlet midlet1)
    {	
		//this.addCommand(exitCmd);
		//this.setCommandListener(this);
		
        midlet = midlet1;
		
		
    }
	
	public void showNotify() {
		new SoundPlayer().start();
	}
	
	void init() {
		Device.setColorMode(Device.COLOR_MODE_256C);
		
		if (!loaded) {
			for(int i = 0; i < MAX_IMG; i++) {
				/*
				try {
					imgs[i] = Image.createImage("/perf/img/" + XDisplay.width 
										+ XDisplay.height2 + "-" + (i + 1) + ".png");
				} catch (Exception e) {
					try {
						imgs[i] = Image.createImage("/perf/img/" + (i + 1) + ".png");
					} catch (Exception ef) {
					}
				}
				*/
				try {
					imgs[i] = Image.createImage("img/" + (i + 1) + ".png");
				} catch (Exception e) {
				}
				
				
				// FIXME : if Image class is updated, this will be removed.
				/*
				if (imgs[i].getWidth() == 10) {
					try {
						imgs[i] = Image.createImage("/img/" + (i + 1) + ".png");
					} catch (Exception ef) {
					}					
				}
				*/
			}			
			loaded = true;
		}
		display = Display.getDisplay(midlet);
		display.setCurrent(this);		
		display.callSerially(this);				
	}

	/*
    String twoDigitOf(int i)
    {
        if(i < 10)
            return "0" + i;
        else
            return String.valueOf(i);
    }
	*/

    public void paint(Graphics g)
    {        
        g.drawImage(imgs[index], 0, 0, Graphics.LEFT | Graphics.TOP);
		g.setGrayScale(Toolkit.WHITE);
		g.fillRect(0, 0, 90, 14);
		g.setGrayScale(Toolkit.BLACK);		
		g.drawString(time, 0, 0, Graphics.LEFT | Graphics.TOP);		
    }
	
	public void commandAction(Command c, Displayable d) {
		if (c == exitCmd) {			
			midlet.notifyDestroyed();			
		}
	}

    public void run()
    {	
		index++;
		if(index == MAX_IMG) {
		    index = 0;
			long l = System.currentTimeMillis();
			int temp = MAX_IMG * 1000 * 10 / (int)(l - oldTime);
			int temp2 = temp/10;
			
			time = String.valueOf(temp2) + "." + String.valueOf(temp - (temp2 * 10)) + " frame/sec";
			oldTime = l;
		}
		display.callSerially(this);
		repaint(0, 0, getWidth(), getHeight() + 16);
    }

}
