/******************************************************************************
	TimerTest.java
		 : Calendar  Timer  
		 :  ð ޴ - Calendar  ¥ ð Ͽ 
			   Ÿ̸  ޴ -  ð ޽   ȭ 
*******************************************************************************/

package phone;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.*;

public class TimerTest extends MIDlet implements CommandListener {

    private Command exitCmd = new Command("Exit", Command.EXIT, 1);
	private Command runCmd = new Command("OK", Command.OK, 2);
    private Display display;	
	private List list = new List("Ÿ̸  ", List.IMPLICIT);
	private Canvas can;

    public TimerTest() {
		list.append(" ð", null);
		list.append("Ÿ̸ ", null);
		
		list.addCommand(exitCmd);
		list.addCommand(runCmd);
		list.setCommandListener(this);
        display = Display.getDisplay(this);		
		
		can = new CalCanvas(display);
		can.addCommand(runCmd);
		can.setCommandListener(this);		
    }
	

    public void startApp() {
        display.setCurrent(list);
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
    }

    public void commandAction(Command c, Displayable d) {
		if (d == list) {
			if (c == runCmd || c == List.SELECT_COMMAND) {
				int selectedIndex = list.getSelectedIndex();
				Alert alert = null;
				switch (selectedIndex) {
					case 0:
						//  ð ޴ ϸ  ð ִ CalCanvas ȯ
						display.setCurrent(can);
						break;
					case 1:
						// Ÿ̸  ޴ ϸ Alert 
						// Alert timeout ϸ  Timer ̿Ͽ 
						alert = new Alert("Ÿ̸ ", "5 Ŀ  ȭ ϴ.", null, AlertType.INFO);
						alert.setTimeout(5000);
						display.setCurrent(alert);					
						break;
				}
			} else if (c == exitCmd) {
			    destroyApp(false);
			    notifyDestroyed();			
			}
		} else if (d == can) {
			if (c == runCmd) {
				display.setCurrent(list);
			}
		}
    }


class CalCanvas extends Canvas implements Runnable {	
	private Display display;
	private Calendar cal = Calendar.getInstance();	
	
	public CalCanvas(Display display) {		
		this.display = display;
	}
	
	public void showNotify() {
		display.callSerially(this);
	}
	
	public void paint(Graphics g) {
		int y = 40;		
		
		g.setGrayScale(255);
		g.fillRect(0, y, getWidth(), getHeight());
		g.setGrayScale(0);
		
		cal.setTime(new Date());		
		String dayOfWeek = null;
		switch (cal.get(Calendar.DAY_OF_WEEK)) {
			case Calendar.SUNDAY:
				dayOfWeek = "";
				break;
			case Calendar.MONDAY:
				dayOfWeek = "";
				break;				
			case Calendar.TUESDAY:
				dayOfWeek = "ȭ";
				break;				
			case Calendar.WEDNESDAY:
				dayOfWeek = "";
				break;				
			case Calendar.THURSDAY:
				dayOfWeek = "";
				break;				
			case Calendar.FRIDAY:
				dayOfWeek = "";
				break;				
			case Calendar.SATURDAY:			
				dayOfWeek = "";
				break;				
		}
		
		StringBuffer buffer = new StringBuffer();
		buffer.append(cal.get(Calendar.YEAR));
		buffer.append(" ");
		buffer.append((cal.get(Calendar.MONTH) + 1));
		buffer.append(" ");
		buffer.append(cal.get(Calendar.DATE));
		buffer.append(" (");
		buffer.append(dayOfWeek);
		buffer.append(")");
		
		g.drawString(buffer.toString() , this.getWidth() / 2, y, Graphics.HCENTER | Graphics.TOP);
		
		buffer = new StringBuffer();
		buffer.append(cal.get(Calendar.HOUR));
		buffer.append(" ");
		buffer.append(cal.get(Calendar.MINUTE));
		buffer.append(" ");
		buffer.append(cal.get(Calendar.SECOND));
		buffer.append(" ");
		
		g.drawString(buffer.toString() , this.getWidth() / 2, y += 14, Graphics.HCENTER | Graphics.TOP);		
	}
	
	public void run() {		
		display.callSerially(this);
		this.repaint();
	}	
}
}
