/******************************************************************************
	FileTest.java
		 :   ׽Ʈ ( ִ    ˱  ׽Ʈ)
		 :  ư    
			    ̻       Ǹ
			       ޽ ˷
*******************************************************************************/

package skvm;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import com.xce.io.*;
import com.xce.util.*;

public class FileTest extends MIDlet implements CommandListener, Runnable {
	
	Display display;
	Form form = new Form("FileTest");
	StringItem sItem = new StringItem(null, "");
	static final Command exitCmd = new Command("", Command.EXIT, 1);
	static final Command runCmd = new Command("", Command.OK, 2);
	static final Command stopCmd = new Command("", Command.CANCEL, 3);
	
	int index;
	boolean isRun;

	public FileTest() {
		index = 0;
		isRun = false;
		
		form.append(sItem);
		form.addCommand(exitCmd);
		form.addCommand(runCmd);
		form.setCommandListener(this);
		
		display = Display.getDisplay(this);
	}
	
	public void startApp() {
		sItem.setText("! ׽Ʈ ɶ Ƿ  ÿ");
		display.setCurrent(form);
	}
	
	public void pauseApp() {
	}
	
	public void destroyApp(boolean unconditional) {
		sItem.setText("");
		notifyDestroyed();
	}
	
	private void start() {		
		isRun = true;
		Thread thread = new Thread(this);
		thread.start();
	}
	
	public void run() {		
		while(isRun) {
			sItem.setText("xfile" + index + " ");
			FileOutputStream out = null;
			try {
				out = new FileOutputStream("xfile" + index);
				out.write(" ".getBytes());				
			} catch (Exception e) {
				break;
			} finally {
				if (out != null) {
					try { out.close(); } catch (Exception e) {}
				}
			}
			index++;
		}
		
		for (int i = 0; i < index; i++) {
			try {
				if( XFile.exists("xfile" + i) ){
					XFile.unlink("xfile" + i);
				}
			} catch (Exception e) {
			}
		}
		sItem.setText(index + "  Ͽϴ");
	}
	
	public void commandAction(Command c, Displayable d) {
		if (c == runCmd) {
			start();
			form.removeCommand(runCmd);
			form.addCommand(stopCmd);
		} else if( c == stopCmd ){
			isRun = false;
			form.removeCommand(stopCmd);
			form.addCommand(runCmd);
		} else if (c == exitCmd) {
			destroyApp(true);
		}
	}
	
}
