/******************************************************************************
	IOTest.java
		 : HTTP, Socket   
		 : HTTP ޴ - HTTP  ּҷκ ͸  
			   Socket(TCP) ޴ - HTTP  ׽Ʈ
		   * HTTP  Socket ϹǷ  ׽Ʈ  
*******************************************************************************/

package skvm;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import javax.microedition.io.*;
import java.io.*;
import com.xce.util.*;

public class IOTest extends MIDlet implements CommandListener, Runnable {
	
	IOCanvas can = new IOCanvas();
	Display display;
	Command exitCmd = new Command("", Command.EXIT, 1);
	Command runCmd = new Command("Ȯ", Command.OK, 2);
	List list = new List("  ", List.IMPLICIT);
	int selectedIndex;
	
	IOTest() {
		list.append("HTTP", null);
		list.append("Socket(TCP)", null);
		//list.append("Datagram(UDP)", null);
		
		list.addCommand(exitCmd);
		list.addCommand(runCmd);
		list.setCommandListener(this);
		
		display = Display.getDisplay(this);
	}
	
	public void startApp() {
		display.setCurrent(list);
	}
	
	public void pauseApp() {
	}
	
	public void destroyApp(boolean unconditional) {
	}
	
	public void commandAction(Command c, Displayable d) {
		if (c == exitCmd) {
			notifyDestroyed();
		} else if (c == runCmd || c == List.SELECT_COMMAND) {
			selectedIndex = list.getSelectedIndex();
			switch (selectedIndex) {
				// ޴ ϸ  ׽Ʈ thread 
				case 0:
				case 1:
				//case 2:
					display.setCurrent(can);
					Thread thread = new Thread(this);
					thread.start();
					break;
			}
		}
	}
	
	public void run() {
		switch (selectedIndex) {
			case 0:
				testHTTP();
				break;
			case 1:
				testSocket();
				break;
			//case 2:
			//	testUDP();
			//	break;
		}		
	}
	
	private void testHTTP() {
		HttpConnection con = null;
		InputStream is = null;
		try {
			con = (HttpConnection)Connector.open("http://www.xce.co.kr/skvm/http.html");
			is = con.openInputStream();
			byte[] buf = new byte[(int)con.getLength()];
			is.read(buf);
			
			Alert alert = new Alert("HTTP ", new String(buf), null, AlertType.INFO);
			alert.setTimeout(Alert.FOREVER);
			display.setCurrent(alert, list);			
		} catch (Exception e) {
			Alert alert = new Alert("HTTP ", e.toString(), null, AlertType.ERROR);
			alert.setTimeout(Alert.FOREVER);
			display.setCurrent(alert, list);
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (Exception e) {
				}
			}
			
			if (con != null) {
				try {
					con.close();
				} catch (Exception e) {
				}
			}
		}
	}
	
	private void testSocket() {
		HttpConnection con = null;
		InputStream is = null;
		try {
			con = (HttpConnection)Connector.open("http://www.xce.co.kr/skvm/socket.html");
			is = con.openInputStream();
			byte[] buf = new byte[(int)con.getLength()];
			is.read(buf);
			
			Alert alert = new Alert("HTTP ", new String(buf), null, AlertType.INFO);
			alert.setTimeout(Alert.FOREVER);
			display.setCurrent(alert, list);			
		} catch (Exception e) {
			Alert alert = new Alert("HTTP ", e.toString(), null, AlertType.ERROR);
			alert.setTimeout(Alert.FOREVER);
			display.setCurrent(alert, list);
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (Exception e) {
				}
			}
			
			if (con != null) {
				try {
					con.close();
				} catch (Exception e) {
				}
			}
		}		
	}
	
	//private void testUDP() {
	//}


class IOCanvas extends Canvas {	
	public void paint(Graphics g) {
		g.drawString("Ʈ ó ", getWidth() / 2, 50, Graphics.TOP | Graphics.HCENTER);
	}
}

}
