/******************************************************************************
	MathTest.java
		 :   ޼ ׽Ʈ
		 : MathFP  ޼带 ׽ƮϿ   
*******************************************************************************/

package skvm;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import com.skt.m.*;
import com.xce.util.*;

public class MathTest extends MIDlet  implements CommandListener {

	private String value1 = "123.451234613241123413421097412";
	private String value2 = "98.761324198419341134132141234";
	private String value3 = "-98.76";
	private String value4 = "0.12";

	private Form form = new Form("Math Test");
	private StringItem si= new StringItem("MathTest","");
    private Display display;	
	private Command exitCmd = new Command("EXIT", Command.EXIT, 1);
	private Command valueCmd = new Command("VALUE", Command.SCREEN, 2);
	

	public MathTest(){
    	display = Display.getDisplay(this);
		form.append(si);
		form.addCommand(exitCmd);
		form.addCommand(valueCmd);
		form.setCommandListener(this);
	}

    public void startApp() {
	   	si.setText(test());
    	display.setCurrent(form);
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
    }

    public void commandAction(Command c, Displayable s) {
		if (c == exitCmd) {
	    	destroyApp(true);
		    notifyDestroyed();
		}	
		else if( c == valueCmd ){
			alert("Test Value", "Value1 : 123.451234613241123413421097412\nValue2 : 98.761324198419341134132141234\nValue3 : -98.76\nValue4 : 0.12");
		}
    }

	String test(){
		StringBuffer data = new StringBuffer();
		
		// long parseFP(long f) : ڿ ǥ   Ҽ  ȯ
		// String toStringLF(long f) :  Ҽ  ڿ ȯ

		// value1 + value2
		data.append("value1 + value2 :\n " + MathFP.toStringLF(MathFP.add( MathFP.parseFPString(value1),MathFP.parseFPString(value2)), 12));
		
		// value1 ݿø
		data.append("\nround(value1) :\n " + MathFP.toStringLF(MathFP.round(MathFP.parseFPString(value1)), 12));
		
		//  Ҽ  value1 Ϲ  ȯ
		data.append("\ntoLong(value1) :\n " + MathFP.toLong(MathFP.parseFPString(value1)));
		
		// value1 / value2
		data.append("\nvalue1 / value2 :\n " + MathFP.toStringLF(MathFP.divide( MathFP.parseFPString(value1),MathFP.parseFPString(value2)), 12));
		
		// value1 * value2
		data.append("\nvalue1 * value2 :\n " + MathFP.toStringLF(MathFP.multiply( MathFP.parseFPString(value1),MathFP.parseFPString(value2)), 12));		
		
		// value1 - value2
		data.append("\nvalue1 - value2 :\n " + MathFP.toStringLF(MathFP.sub( MathFP.parseFPString(value1),MathFP.parseFPString(value2)), 12));
		
		// value1 밪
		data.append("\nabs(value1) :\n " + MathFP.toStringLF(MathFP.abs(MathFP.parseFPString(value3)), 12));	
		
		// value1 
		data.append("\nsqrt(value1) :\n " + MathFP.toStringLF(MathFP.sqrt(MathFP.parseFPString(value1)), 12));
		
		// value1 sine
		data.append("\nsin(value1) :\n " + MathFP.toStringLF(MathFP.sin(MathFP.parseFPString(value1)), 12));
		
		// value1 cosine
		data.append("\ncos(value1) :\n " + MathFP.toStringLF(MathFP.cos(MathFP.parseFPString(value1)), 12));
		
		// value1 tangent
		data.append("\ntan(value1) :\n " + MathFP.toStringLF(MathFP.tan(MathFP.parseFPString(value1)), 12));
		
		// value1, value2 ּҰ
		data.append("\nmin(value1,value2) :\n " + MathFP.toStringLF(MathFP.min( MathFP.parseFPString(value1),MathFP.parseFPString(value2)), 12));
		
		// vlaue1, value2 ִ밪
		data.append("\nmax(value1,value2) :\n " + MathFP.toStringLF(MathFP.max( MathFP.parseFPString(value1),MathFP.parseFPString(value2)), 12));
		
		// value4 arc sine
		data.append("\nasin(value4) :\n " + MathFP.toStringLF(MathFP.asin(MathFP.parseFPString(value4)), 12));
		
		// value4 arc cosine		
		data.append("\nacos(value4) :\n " + MathFP.toStringLF(MathFP.acos(MathFP.parseFPString(value4)), 12));
		
		// value1 arc tangent
		data.append("\natan(value1) :\n " + MathFP.toStringLF(MathFP.atan(MathFP.parseFPString(value1)), 12));
		
		// value1 (exponential number)
		data.append("\nexp(value1) : " + MathFP.toStringLF(MathFP.exp(MathFP.parseFPString(value1)), 12));
		
		// value1 ڿ α
		data.append("\nlog(value1) :\n " + MathFP.toStringLF(MathFP.log(MathFP.parseFPString(value1)), 12));
		
		// value1 value2 
		data.append("\npow(value1,value2) : " + MathFP.toStringLF(MathFP.pow( MathFP.parseFPString(value1),MathFP.parseFPString(value2)), 12));
		
		return data.toString();
	}

	private void alert(String name, String msg){
		Alert alert = new Alert(name);
		alert.setString(msg);
		alert.setTimeout(Alert.FOREVER);
		display.setCurrent(alert);
	}
	
}

