package skvm;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.xce.io.*;
import javax.microedition.io.*;
import java.io.*;
import com.skt.m.*;

public class MelodyTest extends MIDlet implements CommandListener
{
	public Display display;
	
    Form form1;
    	ChoiceGroup choiceGr1;
    	Command exit;
    	Command select1;
    Form formMusicBell;
    	ChoiceGroup choiceGrMusicBell;
    	Command back1;
    	Command setMusicBell;
    Form formMyBell;
    	ChoiceGroup choiceGrMyBell;
    	Command back2;
    	Command setMyBell;

	String snd_mmf = "/skvm/snd0.mmf";
	String snd_ssd = "/skvm/snd1.ssd";
	String snd_ma2 = "/skvm/snd2.ma2";
	String snd_buz = "/skvm/snd4.buz";
	
	byte[] snd_buz_bytes;
	byte[] snd_ma2_bytes;
	byte[] snd_mmf_bytes;
	byte[] snd_ssd_bytes;
    
    public MelodyTest()
    {
    	display = Display.getDisplay(this);
    	
    	form1 = new Form("Melody Test");
    		choiceGr1 = new ChoiceGroup("Select Part",Choice.EXCLUSIVE);
			choiceGr1.append("Music Bell",null);
			choiceGr1.append("My Bell",null);
			exit = new Command("Exit", Command.SCREEN, 2);
			select1 = new Command("Select", Command.SCREEN, 2);
    		form1.append(choiceGr1);
    		form1.addCommand(exit);
    		form1.addCommand(select1);
    		form1.setCommandListener(this);
    		
    	formMusicBell = new Form("Set MusicBell");
    		choiceGrMusicBell = new ChoiceGroup("Choice",Choice.EXCLUSIVE);
			choiceGrMusicBell.append("buzzer",null);
			choiceGrMusicBell.append("ma2",null);
			choiceGrMusicBell.append("mmf",null);
			choiceGrMusicBell.append("evrc",null);
			back1 = new Command("Back", Command.SCREEN, 2);
			setMusicBell = new Command("Set", Command.SCREEN, 2);
			formMusicBell.append(choiceGrMusicBell);
			formMusicBell.addCommand(back1);
			formMusicBell.addCommand(setMusicBell);
			formMusicBell.setCommandListener(this);

    	formMyBell = new Form("Set MyBell");
    		choiceGrMyBell = new ChoiceGroup("Choice",Choice.EXCLUSIVE);
    		choiceGrMyBell.append("buzzer",null);
    		back2 = new Command("Back", Command.SCREEN, 2);
    		setMyBell = new Command("Set", Command.SCREEN, 2);
    		formMyBell.append(choiceGrMyBell);
    		formMyBell.addCommand(back2);
    		formMyBell.addCommand(setMyBell);
    		formMyBell.setCommandListener(this);
    }
    
    /**
     * Pause, discontinue ....
     */
    public void pauseApp() {
    }

    /**
     * Destroy must cleanup everything.  
     */
    public void destroyApp(boolean unconditional){
    }
 
	public void commandAction(Command c, Displayable s) {

		if (c == exit) {
		    destroyApp(false);
		    notifyDestroyed();
		    return;
		}
		if (c == select1) {
		    switch(choiceGr1.getSelectedIndex())
		    {
		    	//Music bell
		    	case 0:
		    		display.setCurrent(formMusicBell);
		    		break;
		    	//My bell
		    	case 1:
		    		display.setCurrent(formMyBell);
		    		break;
		    }
		    return;
		}
		if (c == back1) {
		    display.setCurrent(form1);
		    return;
		}
		if (c == setMusicBell) {
		    switch(choiceGrMusicBell.getSelectedIndex())
		    {
		    	case 0:
		    		Device.setMelody(Device.MELODY_MUSICBELL,snd_buz,snd_buz_bytes);
		    		break;
		    	case 1:
		    		Device.setMelody(Device.MELODY_MUSICBELL,snd_ma2,snd_ma2_bytes);
		    		break;
		    	case 2:
		    		Device.setMelody(Device.MELODY_MUSICBELL,snd_mmf,snd_mmf_bytes);
		    		break;
		    	case 3:
		    		Device.setMelody(Device.MELODY_MUSICBELL,snd_ssd,snd_ssd_bytes);
		    		break;
		    }
		    return;
		}
		if (c == back2) {
			display.setCurrent(form1);
		    return;
		}
		if (c == setMyBell) {
		    switch(choiceGrMyBell.getSelectedIndex())
		    {
		    	case 0:
		    		Device.setMelody(Device.MELODY_MYBELL,snd_buz,snd_buz_bytes);
		    		break;
		    }
		    return;
		}
	}    


    /**
     * This will be invoked when we start the MIDlet
     */
	public void startApp() {
		display.setCurrent(form1);	
		try{
			InputStream inStrm1 = this.getClass().getResourceAsStream(snd_buz);
			InputStream inStrm2 = this.getClass().getResourceAsStream(snd_ma2);
			InputStream inStrm3 = this.getClass().getResourceAsStream(snd_mmf);
			InputStream inStrm4 = this.getClass().getResourceAsStream(snd_ssd);
			snd_buz_bytes = new byte[inStrm1.available()];
			snd_ma2_bytes = new byte[inStrm2.available()];
			snd_mmf_bytes = new byte[inStrm3.available()];
			snd_ssd_bytes = new byte[inStrm4.available()];
			inStrm1.read(snd_buz_bytes);
			inStrm2.read(snd_ma2_bytes);		
			inStrm3.read(snd_mmf_bytes);
			inStrm4.read(snd_ssd_bytes);
		}catch(IOException ioe){ioe.printStackTrace();}
	}

}
