/*
 * @(#)lcWin.c	1.3 01/08/21
 * Copyright (c) 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include "global.h"
#include "defaultLCDUI.h"
#include "lcWin.h"

extern LcWinMethods getJaWinMethods();

LcWinMethods
getLcWinMethods(char *locale)
{
    if (locale && *locale) {
        if (strncmp(locale, "ja", 2) == 0) {
            return getJaWinMethods();
        }
#ifdef LATER
        if (strncmp(locale, "ko", 2) == 0) {
            return getKoWinMethods();
        }
        if (strncmp(locale, "zh", 2) == 0) {
            return getZhWinMethods();
        }
#endif
    }
    return NULL;
}
