/*
 * @(#)lcWin.h	1.7 00/11/20
 * Copyright (c) 1999,2000 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#ifndef _LCWIN_H_INCLUDED
#define _LCWIN_H_INCLUDED

#include <X11/Xlib.h>

typedef struct _LcWinMethodsRec {
    void (*init)(Display *d);
    void (*convertText)(FONTPARAMS_PROTO, 
                        const unicode *s,     int len,
                        XTextItem16 **items,  int *numItems,
                        XTextItem16 *itemBuf, int itemBufSize,
                        XChar2b *charBuf,     int charBufSize);
    XFontStruct *(*getFontStruct)(Font f);
    void (*getFontInfo)(FONTPARAMS_PROTO, 
                        int *ascent, int *descent, int *leading);
} LcWinMethodsRec, *LcWinMethods;

extern LcWinMethods getLcWinMethods(char *locale);

#endif
