# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgcodesigning.mk	1.13 99/09/21
#
# Makefile for the shared part of codesigning.

####################
# exported variables
####################

OPTIONALSRCDIRS	+= $(OPTIONALSHARESRCDIR)/codesigning
PJAVAKEYJAR	=  tools/pjavakey$G.jar
BUILDDIRS	+= tools

# these classes are in $(CLASSES) but are ommitted from classes.zip
PJAVAKEYONLYCLASSES = \
	sun/security/provider/Main.class


#######################
# The pjavakey.jar file
#######################


PJAVAKEYTEMPDIRS = \
	.pjavakeyclasses$G/sun \
	.pjavakeyclasses$G/sun/io \
	.pjavakeyclasses$G/sun/pjava \
	.pjavakeyclasses$G/java/io \
	.pjavakeyclasses$G/sun/applet \
	.pjavakeyclasses$G/sun/tools/jar

$(PJAVAKEYTEMPDIRS) :
	@echo ... mkdir $@
	@if [ ! -d $@ ]; then mkdir -p $@; fi

$(PJAVAKEYJAR) :: tools

$(PJAVAKEYJAR) :: $(PJAVAKEYTEMPDIRS) $(ZIPPEDCLASSES)
	echo "... making $@"
	cd classes$G; cp -f -r sun/security ../.pjavakeyclasses$G/sun; \
	cp -f -r java/security ../.pjavakeyclasses$G/java/security; \
	cp -f java/io/ObjectStreamClass.class ../.pjavakeyclasses$G/java/io; \
	cp -f sun/applet/AppletSecurity.class ../.pjavakeyclasses$G/sun/applet; \
	cp -f sun/tools/jar/JarVerifierStream.class sun/tools/jar/SignatureFile.class ../.pjavakeyclasses$G/sun/tools/jar
	cd ../share/precompiled$G; cp -f sun/io/*.class ../../$(PLATFORM)/.pjavakeyclasses$G/sun/io
	cd .pjavakeyclasses$G; CLASSPATH=$(ZIPPEDCLASSES); export CLASSPATH; $(JAVATOP)/bin/jar cf pjavakey_tmp.jar .
	mv .pjavakeyclasses$G/pjavakey_tmp.jar $@
