# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgmath.mk	1.2 98/09/18
#
# Makefile for the shared part of the java math package.

####################
# exported variables
####################

CLASSES		+= $(MATHCLASSES)
HEADERCLASSES	+= $(MATHSTUBCLASSES)

ifeq ($(STATICLIBRARIES), true)
SHAREOBJECTS	+= $(MATHSHAREOBJECTS)
STUBCLASSES	+= $(MATHSTUBCLASSES)
else
CLASSSTUBFILES	+= MATHclassstubs.c
endif


#################
# classes
#################

MATHSTUBCLASSES = \
	java.math.BigInteger

MATHCLASSES = \
	java.math.BigInteger \
	java.math.BigDecimal


###############
# objects
###############

MATHSHAREOBJECTS = \
        plumbNum.o \
        bn.o \
        bn00.o \
        germain.o \
        jacobi.o \
        lbn00.o \
        lbnmem.o \
        legal.o \
        prime.o \
        sieve.o
