# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)properties_win32.mk	1.5 98/12/03
#
# Makefile for specifying all of the win32 properties files.

GUI = windows

PLATFORMPROPERTIES = \
	content-types.properties

#############################
# AWT localization properties
#############################

properties :: $(AWTLPROPERTIESDEST) 

AWTLPROPERTIESSDIR	= $(WIN32_SUN)\sun\awt\windows

AWTLPROPERTIES_en_US	= awtLocalization.properties
AWTLPROPERTIES_ja	= awtLocalization_ja.properties
AWTLPROPERTIES_ALL	= $(AWTLPROPERTIES_en_US) $(AWTLPROPERTIES_ja)
AWTLPROPERTIES		= $(AWTLPROPERTIES_$BUILDLOCALE))

AWTLPROPERTIESDEST	= \
	$(addprefix $(CLASSESDIR)/sun/awt/windows/, $(AWTLPROPERTIES))
AWTLPROPERTIESSSRC	= \
	$(addprefix $(AWTLPROPERTIESDIR)/, $(AWTLPROPERTIES))

$(AWTLPROPERTIESDEST) : $(AWTLPROPERTIESSSRC)
	cp $(AWTLPROPERTIESSDIR)/$(notdir $@) $(CLASSESDIR)/sun/awt/windows

##############
# rules
##############

$(PLATFORMPROPERTIESDEST) : $(PLATFORMPROPERTIESSRC)
	cp $(PLATFORMPROPERTIESDIR)/$(notdir $@) lib

$(SHAREDPROPERTIESDEST) : $(SHAREDPROPERTIESSRC) 
	cp $(SHAREDPROPERTIESDIR)/$(notdir $@) lib

lib/security/java.security:: $(SHAREDPROPERTIESDIR)/security/java.security
	cp $< lib/security

$(FONTPROPERTIESDEST) : $(FONTPROPERTIESSRC)
	cp $(FONTPROPERTIESDIR)/$(notdir $@) lib

$(PALETTEPROPERTIESDEST) : $(PALETTEPROPERTIESSRC) 
	cp $(PALETTEPROPERTIESDIR)/$(notdir $@) lib

