/*
 * @(#)GroupingColorPolicy.java	1.2 98/07/24 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.touchable;

import java.awt.Color;

/* This Color policy is used for List
 */
class GroupingColorPolicy extends BasicColorPolicy{

    Color grouping = null;

    GroupingColorPolicy(Color bg, Color hiliteBg, Color inactiveBg,
			Color fg, Color hiliteFg, Color inactiveFg,
			Color grouping, Color eraseColor, 
			boolean getEraseFromParent){

	super(bg, hiliteBg, inactiveBg, 
	      fg, hiliteFg, inactiveFg,
	      eraseColor, getEraseFromParent);

	this.grouping = grouping;
    }

    Color getGroupingColor(){
	return grouping;
    }
}
