/*
 * @(#)TouchableContainerView.java	1.2 98/10/05 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.*;

class TouchableContainerView extends TouchableView implements ContainerView {
    public TouchableContainerView(ComponentModel model,
				  ObjectToolkit toolkit,
				  ContainerView parent,
				  ColorPolicy colors) {
	this(model, toolkit, parent, colors, NULL_BOUNDS);
    }

    public TouchableContainerView(ComponentModel model,
				  ObjectToolkit toolkit,
				  ContainerView parent,
				  ColorPolicy colors,
				  Rectangle bounds) {
	super(model, toolkit, parent, colors, bounds);
    }

    public TouchableContainerView(ComponentModel model,
				  ObjectToolkit toolkit,
				  ContainerView parent,
				  ColorPolicy colors,
				  Rectangle bounds,
				  int windowType) {
	super(model, toolkit, parent, colors, bounds, windowType);
    }

    public sun.porting.windowsystem.Window getContainerWindow() {
	return super.getContainerWindow();
    }

    // do not show focus
    public void drawFocus(){
    }
}
