/*
 * @(#)OrderedListImpl.java	1.3 98/11/30 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

/**
 * OrderedListImpl essentially extends the java.util.Vector
 * class.  The methods that are contained in the OrderdList
 * interface are already part of the java.util.Vector class.
 * So the purpose of this class is to use the interface to expose
 * only those methods of the Vector class that are directly
 * relevant to implementing an ordered list.
 */
class OrderedListImpl extends java.util.Vector implements OrderedList {
    public OrderedListImpl(int nitems) {
	super(nitems);
    }

    public OrderedListImpl(int nitems, int capacity) {
	super(nitems, capacity);
    }
}

