/*
 * @(#)TextPaneScroller.java	1.3 98/11/30 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.otk;

/**
 * This interface establishes the contract between a TextPane and it's 
 * parent view for synchronizing scrollbars that are actually part of the
 * parent.
 * @see sun.awt.otk.TextPane
 * @see sun.awt.otk.TextComponentView
 */
public interface TextPaneScroller {
    void resizeScrollbars(int vsbVal, int vsbVis, int vsbMin, int vsbMax,
			  int hsbVal, int hsbVis, int hsbMin, int hsbMax);
}
