/*
 * @(#)common_exceptions.h	1.11 98/09/04
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Common exceptions thrown from within the interpreter (and
 * associated libraries).
 */

#ifndef	_COMMON_EXCEPTIONS_H_
#define	_COMMON_EXCEPTIONS_H_

struct execenv;

/* JAVAPKG */
void ThrowOutOfMemoryError(struct execenv *ee, char *s);
void ThrowStackOverflowError(struct execenv *ee, char *s);
void ThrowStringIndexOutOfBoundsException(struct execenv *ee, char *s);
void ThrowIllegalArgumentException(struct execenv *ee, char *s);
void ThrowArrayIndexOutOfBoundsException(struct execenv *ee, char *s);

#endif	/* !_COMMON_EXCEPTIONS_H_ */
