/*
 * @(#)UnsupportedOperationException.java	1.5 98/06/25 SMI
 * 
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */
package java.lang;

/*
 * This class is a subclass com.sun.lang.UnsuportedOperationException so
 * that PersonalJava can throw java.lang.UnsuportedOperationException and
 * still have it be caught by PersonalJava applications and applets that
 * catch com.sun.lang.UnsuportedOperationException. PersonalJava
 * applications and applets that expect to run on JDK 1.1.x should package
 * com.sun.lang.UnsupportedOperationException with the application or applet.
 */

public class UnsupportedOperationException extends com.sun.lang.UnsupportedOperationException {

  public UnsupportedOperationException() {
  }

  public UnsupportedOperationException(String s) {
    super(s);
  }
}
