/*
 * @(#)class.c	1.1 98/11/18
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*-
 *      Implementation of class Class
 *
 *      former threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>

#include "tree.h"
#include "javaString.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "reflect.h"
#include "utf.h"

#include "java_lang_Class.h"
#include "java_lang_ClassLoader.h"

extern ClassClass *allocClassClass(void);

struct methodblock *loadClassInternal = NULL;

/* This is called by FindClassFromClass when a class name is being requested
 * by another class that was loaded via a classloader.
 */

ClassClass *
ClassLoaderFindClass(ExecEnv *ee, Hjava_lang_ClassLoader *loader, 
		     char *name, bool_t resolve)
{
    Hjava_lang_String *stringName = makeJavaStringUTF(name);
    Hjava_lang_Class *c = (Hjava_lang_Class *)do_execute_java_method(ee, 
						 (HObject *)loader, 
						 NULL, NULL, loadClassInternal,
						 FALSE, 
						 stringName, resolve);
    return c;
}
