/*
 * @(#)java_lang_Runtime_totalMemory.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Link foreign methods.  This first half of this file contains the
 *	machine independent dynamic linking routines.
 *	See "BUILD_PLATFORM"/java/lang/linker_md.c to see
 *	the implementation of this shared dynamic linking
 *	interface.
 *
 *	NOTE - source in this file is POSIX.1 compliant, host
 *	       specific code lives in the platform specific
 *	       code tree.
 */

#include "oobj.h"
#include "interpreter.h"
#include "tree.h"
#include "javaString.h"

#include "sys_api.h"
#include "path.h"
#include "finalize.h"

/* This is a hack to make sure that the stubs are linked properly */
/* There has to be some reference to a stub otherwise none of the */
/* stubs are included in the link */
extern int Java_java_lang_Runtime_loadFileInternal_stub(void);
static void *bogus_reference =
     (void *)&Java_java_lang_Runtime_loadFileInternal_stub;

#include "java_lang_Runtime.h"

int64_t
java_lang_Runtime_totalMemory(Hjava_lang_Runtime *this)
{
    return ll_add(TotalObjectMemory(), TotalHandleMemory());
}
