/*
 * @(#)java_util_ResourceBundle_getLoaderCache.c	1.2 98/10/09
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

#include "native.h"
#include "java_lang_ClassLoader.h"
#include "java_lang_Object.h"
#include "java_util_ResourceBundle.h"

#define	REFLECTPKG "java/lang/reflect/"


Hjava_lang_Object *
java_util_ResourceBundle_getLoaderCache(Hjava_util_ResourceBundle *notUsed,
					Hjava_lang_ClassLoader *cl)
{
    return (Hjava_lang_Object *) 
	execute_java_dynamic_method(EE(), (HObject*) cl, 
				    "getResourceBundleCache",
				    "()Ljava/lang/Object;");
}
