/*
 * @(#)HashSet.java	1.1 98/08/20 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.tools.agent;

import java.util.Hashtable;

class HashSet extends Set {
    Iterator iterator() {
	return new EnumerationIterator(h.keys());
    }
    boolean add(Object o) {
	return h.put(o, PRESENT)==null;
    }
    void clear() {
	h.clear();
    }

    private Hashtable h = new Hashtable();

    // Dummy value to associate with an Object in the backing Map
    private static final Object PRESENT = new Object();
}
