/*
 * @(#)DefaultFontCharset.java	1.1 98/07/27
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.gfW;

import sun.io.CharToByteISO8859_1;


public class DefaultFontCharset extends CharToByteISO8859_1
{
    // Name for Windows FontSet.
    private String fontName;

    public DefaultFontCharset(String name){
	fontName = name;
    }

    public synchronized native boolean canConvert(char ch);

    public String toString() {
	return "DefaultFontCharset";
    }

    private native static void initJNI();
    static { initJNI(); }
}
