/*
 * @(#)sun_audio_AudioDevice_audioWrite.c	1.1 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <io.h> 
#include <fcntl.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#include <stdio.h> 
#include <windows.h> 
#ifdef WIN32_LEAN_AND_MEAN
#include <mmsystem.h>
#endif

#include "sunaudio_common.h"
#include "sun_audio_AudioDevice.h"

void
sun_audio_AudioDevice_audioWrite(struct Hsun_audio_AudioDevice *Hthis,
				     HArrayOfByte *Hbuf,
				     long dataLen)
{
    if (Hbuf == NULL) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
    } else if (dataLen > 0) {
	char *data = unhand(Hbuf)->body;
	if (obj_length(Hbuf) < dataLen) {
	    dataLen = obj_length(Hbuf);
	}
	audioWrite(data, dataLen);
    }
}
