/*
 * @(#)stdhdrs.h	1.6 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef _STDHDRS_H_
#define _STDHDRS_H_

// standard Windows and C headers
#define VC_EXTRALEAN	/* speeds compilation */
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>
#include <limits.h>

extern "C" {

// standard Java headers
#include <native.h>
#include <monitor.h>
#include <oobj.h>
#include <interpreter.h>
#include <tree.h>
#include <javaString.h>
#include <exceptions.h>

} // extern "C"

#endif // _STDHDRS_H_
