/*
	File : SoundMan.java
	Date		Author		Change
	2001/09/19	Kim.K.C.	Created
	2001/10/11	Kim.K.c.	Network  ߰  Ű ̸ 

带 ϱ  .
*/

package com.xce.xceman.client;

import com.skt.m.*;
import java.io.*;

class SoundMan extends Thread {
	public static final int SND_WALK = 0;
	public static final int SND_BELL = 1;
	
	byte[][] snd = new byte[2][];
	AudioClip clip;
	int curr;
	boolean playing;
	
	void loadResource() {
		try {
			Class thisClass = this.getClass();
			int len;
			
			/**
			 * Connector ӿ Ͽ .jar ȭϿ ִ ҽ
			 *    ڴ  getResourceAsStream() ȣѴ.
			 */
			InputStream in = thisClass.getResourceAsStream("/snd/walk.ssd");			
			len = in.available();
			snd[0] = new byte[len];
			in.read(snd[0], 0, len);
			in.close();
			
			in = thisClass.getResourceAsStream("/snd/bell.ssd");
			len = in.available();
			snd[1] = new byte[len];
			in.read(snd[1], 0, len);
			in.close();
			
			clip = AudioSystem.getAudioClip("evrc");
		} catch (Exception e) {
		}
	}
	
	/**
	 * ̷  ߰ close() ȣϰ Ǹ 尡
	 *   Ͼ. ʿ信  带 
	 * ʰ ϴ 쵵   ̴.
	 */
	public synchronized void play(int index) {
		try {
			clip.close();
		} catch (Exception e) {
		}
		playing = true;
		curr = index;
		this.notify();		
	}
	
	public void run() {
		while (true) {
			synchronized (this) {
				try {
					while (!playing) {
						this.wait();
					}
				} catch (Exception e) {
				}
			}
			try {
				clip.open(snd[curr], 0, snd[curr].length);
				clip.play();
				synchronized (this) {
					playing = false;
				}				
			} catch (Exception e) {
			} finally {
				try {
					clip.close();				
				} catch (Exception e) {
				}
			}
		}
	}
}