/*
	File : Protocol.java
	Date		Author		Change
	2001/10/11	Kim.K.C.	Created

Ŷ    ִ.
*/

package com.xce.xceman.common;

public interface Protocol {
	
	public static final int MAX_MAN = 10;	
	public static final int MAX_LEN = 4;
	/**
	 * SEND :
	 *		CONNECT
	 * RECEIVE :
	 *		CONNECT | ID
	 */
	public static final int CONNECT = 1;
	
	/**
	 * SEND :
	 *		MOVE | X | Y
	 * RECEIVE :
	 *		MOVE | ID | X | Y
	 */	
	public static final int MOVE	= 3;
	
	/**
	 * SEND :
	 *		EXIT
	 * RECEIVE :
	 *		EXIT | ID
	 */	
	public static final int EXIT	= 4;
}