REM NOKIA APPLICATION BUILDER
REM MobileJava.co.kr Ǳ(crony94@hanmail.net)

REM The application specific information
SET MAINCLASS=Nokia7650HelloWorld

REM The target path
SET JAVA_HOME=d:\java\jdk1.3
SET SRCDIR=src
SET CLASSDIR=classes
SET VERIFIED_CLASSDIR=preverified-temp
SET NOKIA7650_HOME=D:\MobileProgram\Nokia_Developers_Suite\Emulators\Nokia_Series_60_MIDP_SDK_Beta_0_1
SET NOKIA7650_CLASSDIR=%NOKIA7650_HOME%\lib\j2me-debug.zip

REM compile
MKDIR %CLASSDIR%
%JAVA_HOME%\bin\javac -bootclasspath %NOKIA7650_CLASSDIR% -d %CLASSDIR% %SRCDIR%\*.java

REM preverify
%NOKIA7650_HOME%\bin\preverify -classpath %NOKIA7650_CLASSDIR% -d %VERIFIED_CLASSDIR% %CLASSDIR%

REM jar create
cd %VERIFIED_CLASSDIR%
jar cvfm %MAINCLASS%.jar ../%MAINCLASS%.jad -C  . .
copy %MAINCLASS%.jar ..
del %MAINCLASS%.jar
cd ..