/*
 * 
 * Java TV API  ̿ ȭ鿡 HelloWorld ϴ  
 */
 
// ̺귯 ߰
import java.awt.*;
import java.awt.event.*;
import javax.tv.graphics.*;
import javax.tv.xlet.*;

public class JavaTVHelloWorld extends Component implements Xlet 
{
  private Container root;
  
  public synchronized void initXlet(XletContext ctx) throws XletStateChangeException 
  {
    // TV ȭ鿡 شϴ Container 
    root = TVContainer.getRootContainer(ctx);
	// TV Container Layout 
	root.setLayout(null);
	// TV Container ġ 
	root.setBounds(0, 0, 1024, 768);
	
	//  Xlet ġ 
	setBounds(100, 100, 500, 500);
	System.out.println("Xlet initialized.");
  }
  
  public synchronized void startXlet() throws XletStateChangeException 
  {
    // TV Container  Xlet ϰ, ȭ鿡 ̰ 
    root.add(this);
	root.setVisible(true);
	root.repaint();
	System.out.println("Xlet started. Hello!");
  }
  
  public synchronized void pauseXlet() 
  {
    //  Xlet TV Container 
    root.remove(this);
	root.repaint();
	System.out.println("Xlet paused.");
  }
  
  public synchronized void destroyXlet(boolean unconditional) throws XletStateChangeException 
  {
    //  Xlet TV Container 
    if (root != null) 
	{
	  root.removeAll();
	  root.repaint();
	}
	//  ÷ 
	System.gc();
	System.out.println("Xlet destroyed.  Goodbye!");
  }
  
  public void paint(Graphics g) 
  {
    // ȭ餷 Hello World 
    g.setColor(getForeground());
	g.drawString("Java TV Hello World", 0, 100);
  }
}
