@echo off

rem This batch file builds and preverifies the code for the demos.
rem it then packages them in a JAR file appropriately.

echo *** Creating directories ***
echo *** (this stage may produce already exist errors. Ignore them). ***

mkdir ..\tmpclasses
mkdir ..\classes

echo *** Compiling source files ***

javac -bootclasspath %MIDP_HOME%\classes -d ..\tmpclasses -classpath ..\tmpclasses ..\src\*.java

echo *** Preverifying class files ***

rem WARNING: When running under windows 9x the JAR may be incomplete
rem due to a bug in windows 98. Simply place a pause statement between
rem the preverify and JAR stages and wait 5 seconds before continuing
rem the build.

%MIDP_HOME%\bin\preverify -classpath %MIDP_HOME%\classes;..\tmpclasses -d ..\classes ..\tmpclasses

echo *** Jaring preverified class files ***
jar cmf MANIFEST.MF HelloMIDlet.jar -C ..\classes .

echo *** Jaring resource files ***
jar umf MANIFEST.MF HelloMIDlet.jar -C ..\res .

echo *** Don't forget to update the JAR file size in the JAD file ***

