import java.util.*;
import javax.microedition.lcdui.*;

public class MineCanvas extends Canvas implements Runnable {
   final static int DEFAUL_DELAY_TIME=100;

   Display         display;

   static         int sqlength=5;	            // length of tetris square
   static final   int xoffset=43;	            // distance from left
   static         int cols=10;		            // columns
   static         int rows=19;		            // rows
   int                f[][]; 			            // field
   int                of[][]; 		            // old field
   int                curWhat, newWhat;	      // type of current piece
   Block              curpiece[]=new Block[4];	// current piece
   Block              newPiece[]=new Block[4];
   boolean            lost;			            // lost
   boolean            needNewPiece;		         // need new piece
   Thread             killMe=null;		         // thread that does gravity
   int                curval, score=0;
   int                level=1;			         // current level of difficulty
   int                pieces;			            // nr of pieces dropped
   boolean            justUpdating = false;
   boolean            isStart=false;

   //  ۸  -ũ ̹
   Image offImage=null;
   Graphics offGraphics=null;

   public MineCanvas(Display dis) {
      display = dis;
   }

   // ο Ʈ  Ѵ.
   private Block[] selectNewPiece() {
      Block  temp[] = new Block[4]; // Ʈ   ¥
      int m = cols / 2;             
      Random rand = new Random();   // Ʈ    

      newWhat = (int)rand.nextInt() % 7;  // Ʈ   7̹Ƿ (0~6)
      if(newWhat < 0) {
         newWhat = -newWhat;   //    ȯ
      }

      //  شϴ Ʈ  Ѵ.
      // ϳ Ʈ  4  ȴ.
      switch(newWhat) {
         case 0:
            // XXXX
            curval = 2;
            temp[0] = new Block(m-1, rows-1, 1, this.cols, this.rows);
            temp[1] = new Block(m-2, rows-1, 1, this.cols, this.rows);
            temp[2] = new Block(m,   rows-1, 1, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-1, 1, this.cols, this.rows);
         break;
         case 1:
            //  X
            // XXX
            curval = 3;
            temp[0] = new Block(m  , rows-2, 5, this.cols, this.rows);
            temp[1] = new Block(m  , rows-1, 5, this.cols, this.rows);
            temp[2] = new Block(m-1, rows-2, 5, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-2, 5, this.cols, this.rows);
         break;
         case 2:
            // XX
            //  XX
            curval = 4;
            temp[0] = new Block(m  , rows-2, 2, this.cols, this.rows);
            temp[1] = new Block(m-1, rows-1, 2, this.cols, this.rows);
            temp[2] = new Block(m  , rows-1, 2, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-2, 2, this.cols, this.rows);
         break;
         case 3:
            //  XX
            // XX
            curval = 4;
            temp[0] = new Block(m  , rows-2, 7, this.cols, this.rows);
            temp[1] = new Block(m+1, rows-1, 7, this.cols, this.rows);
            temp[2] = new Block(m  , rows-1, 7, this.cols, this.rows);
            temp[3] = new Block(m-1, rows-2, 7, this.cols, this.rows);
         break;
         case 4:
            //  XX
            //  XX
            curval = 2;
            temp[0] = new Block(m-1, rows-1, 3, this.cols, this.rows);
            temp[1] = new Block(m  , rows-1, 3, this.cols, this.rows);
            temp[2] = new Block(m-1, rows-2, 3, this.cols, this.rows);
            temp[3] = new Block(m  , rows-2, 3, this.cols, this.rows);
         break;
         case 5:
            //  XXX
            //    X
            curval = 3;
            temp[0] = new Block(m  , rows-1, 6, this.cols, this.rows);
            temp[1] = new Block(m-1, rows-1, 6, this.cols, this.rows);
            temp[2] = new Block(m+1, rows-1, 6, this.cols, this.rows);
            temp[3] = new Block(m+1, rows-2, 6, this.cols, this.rows);
         break;
         case 6:
            //  XXX
            //  X
            curval = 3;
            temp[0] = new Block(m  , rows-1, 4, this.cols, this.rows);
            temp[1] = new Block(m+1, rows-1, 4, this.cols, this.rows);
            temp[2] = new Block(m-1, rows-1, 4, this.cols, this.rows);
            temp[3] = new Block(m-1, rows-2, 4, this.cols, this.rows);
         break;
      }

      return(temp);
   }

   // ο  ϳ  ,
   // Ʈ    ִ ȮѴ.
   private void newPiece() {
      //  Ʈ  ϳ Ѵ.
      Block  old[] = new Block[4];
      old[0] = new Block(-1, -1, 0, this.cols, this.rows);
      old[1] = old[0];
      old[2] = old[0];
      old[3] = old[0];

      this.curpiece = this.newPiece;
      this.curWhat = this.newWhat;

      // ο Ʈ  Ѵ.
      this.newPiece = selectNewPiece();

      // Ӱ  Ʈ  Ʒ ̵ų  ִ ȮѴ.
      // ó ̵ų  ٴ  Ʈ   
      // Ʈ  Ǿٴ  ǹѴ.
      lost = !movePiece(old, curpiece);
   }

   // Ʈ  ο ġ ̵ų  ִ ȮѴ.
   // ̵ų  ٸ false  Ѵ.
   private boolean movePiece(Block from[], Block to[]) {
      outerlabel:
      for(int i=0; i<to.length; i++) {
         if(!to[i].inBounds()) {
            // Ʈ  輱 ִٴ 
            // Ʈ  ̵ų  ٴ  ǹѴ.
            return false;
         }

         // ̵ ġ  ְ
         // ̵ų  浹 ߻ϴ üũѴ.
         if(f[to[i].getX()][to[i].getY()] != 0) {	// it's taken
            for(int j=0; j<from.length; j++) {
               if(to[i].isEqual(from[j])) {
                  continue outerlabel;		// but by a from
               }
            }
            return false;	// no can do
         }
      }

      // Ʈ  ̵ϱ  ġ  0 ν,
      // Ʈ  ̵ ȿ .
      for(int i=0; i<from.length; i++) {
         if(from[i].inBounds()) {
            // Ʈ  (f) ̵   ִ ġ  
            // 0 ν .
            f[from[i].getX()][from[i].getY()] = 0;
         }
      }

      // Ʈ ̵ ġ   Ʈ  ()
      // ν Ʈ  ̵ ȿ ش.
      for(int i=0; i<to.length; i++) {
         f[to[i].getX()][to[i].getY()] = to[i].getColor();
      }

      // Ʈ   ̵״ٸ true  Ѵ.
      return true;
   }

   // Ʈ  ̵Űų Ǵ ȸ Ų.
   private synchronized boolean moveCurrPiece(int byx, int byy, boolean rotate) {
      Block newpos[] = new Block[4];

      for(int i=0;i<4;i++) {
         if(rotate) {
            // rotate  true̸ Ʈ  ȸŲ.
            int dx = curpiece[i].getX() - curpiece[0].getX();
            int dy = curpiece[i].getY() - curpiece[0].getY();
            newpos[i] = new Block(curpiece[0].getX() - dy,
                                  curpiece[0].getY() + dx,
                                  curpiece[i].getColor(),
                                  this.cols, this.rows);
         } else {
            // rotate  false̸ Ʈ  ־ ġ ̵Ų.
            newpos[i] = new Block(curpiece[i].getX() + byx,
                                  curpiece[i].getY() + byy,
                                  curpiece[i].getColor(),
                                  this.cols, this.rows);
         }
      }

      // Ʈ   ġ(curpiece)
      // ο ġ(newpos) ̵Ų.
      // ϰ true̸  ̵Ų ̰,
      // false ̸ ̵Ű  ߴٴ  ǹѴ.
      if(!movePiece(curpiece, newpos)) {
         return false;
      }

      //  Ʈ  ̵  ο Ʈ  Ѵ.
      curpiece = newpos;

      return true;
   }

   // Ʈ  ̵Ų ,     .
   private void removeLines() {
      outerlabel:
      for(int j=0; j<rows; j++) {
         for(int i=0; i<cols; i++) {
            if(f[i][j] == 0) {
               continue outerlabel;
            }
         }

         for(int k=j; k<rows-1; k++) {
            for(int i=0; i<cols; i++) {
               f[i][k] = f[i][k+1];
            }
         }
         j--;
      }
   }

   // Ʈ  Ӱ Ѵ.
   public void  newGame() {	
      this.stop();      //  带 Ѵ.

      sqlength = 5;
      cols = 10;
      rows = 19;

      f = new int[cols][rows+4];	   // Ʈ ()
      of = new int[cols][rows+4];	// Ʈ () - old

      // Ʈ  ʱȭѴ.
      //     ν,
      // ش   ġߴٴ  Ÿ  ִ.
      for(int i=0; i<cols; i++) {
         for(int j=0; j<rows+4; j++) {
            f[i][j] = 0; 
            of[i][j] = -1;
         }
      }

      //    ʱȭѴ.
      level = 1;
      score = 0;
      pieces = 0;
      curval = -1;
      needNewPiece = true;
      this.newPiece = this.selectNewPiece(); // ο Ʈ  Ѵ.
      lost = false;  //  ϹǷ   ƴϴ.
                     // lost   true̸  Ǿٴ  ǹ

      this.isStart = false;

      // Ʈ  Ʈ  Ʒ ߸  ʿ
      killMe = new Thread(this);    // Ʈ  
      killMe.start();               // Ʈ  
   }

   // Ʈ  
   public void start() {
//      display.setCurrent(this);
      this.isStart = true;
      repaint();
   }

   // Ʈ  
   public synchronized void stop() {
      if(this.killMe != null && this.killMe.isAlive()) {
         // Ʈ 尡 ߿  쿡 Ѿ Ѵ.
         this.killMe = null;  // ڹٿ 带 Ű  
                              // killMe.stop() ޼ҵ带 ȣ ʰ,
                              // killMe = null;   ϵ ϰ ִ.
         this.lost = true;    //   ǥѴ.
      }
   }

   // Ʈ  ٵ
   public void run() {
      //    ̸ ª ش.
      int delayTime[] = new int[] { 400, 370, 330, 300, 270,
                                    250, 230, 200, 170, 130 };

      //     尡 Ѵ.
      // Ӱ  Ʈ  ̵ų   ,
      // lost  true ȴ.
      while(!lost) {
         try {
            //   ̸ ش.
            if((level >= 1)||(level <= delayTime.length)) {
               Thread.sleep(delayTime[level-1]);
            } else {
               Thread.sleep(DEFAUL_DELAY_TIME);
            }
         } catch(InterruptedException e) {
         }

         // ο Ʈ   ʿ䰡 ִ üũ
         if(needNewPiece) {
            //  ¸ Ӱ 
            if(curval > 0) {
               score += curval;           //  
               pieces++;                  //  Ʈ   
               level = 1 + pieces / 30;   //  Ʈ  °  
            }
            removeLines();          //       
            newPiece();             // ο Ʈ  
            needNewPiece = false;   // needNewPiece  ٽ ʱȭ
         } else {
            // Ʈ  Ʒ  ĭ ̵Ų.
            // Ʈ  Ʒ  ̻ ̵ų   쿡
            // Ʈ    ̹Ƿ
            // ο Ʈ  ؾ Ѵ.
            needNewPiece = !moveCurrPiece(0, -1, false);	
         }
         repaint();  // ȭ ٽ ׷ش.
      }
      killMe = null;    //  ٵ  Ƿ
                        // killMe null Ѵ.
   }

   //  Ʈ  ׸.
   private void drawNextPiece(Graphics g) {
      g.drawString("Next piece" , 3, 5, 20);
      int startx= 8, starty=22;

      switch(newWhat) {
         case 0:
            // XXXX
            g.fillRect(startx, starty+3, sqlength*4, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx, starty+3, sqlength, sqlength);
            g.drawRect(startx+sqlength, starty+3, sqlength, sqlength);
            g.drawRect(startx+sqlength*2, starty+3, sqlength, sqlength);
            g.drawRect(startx+sqlength*3, starty+3, sqlength, sqlength);
         break;
         case 1:
            //  X
            // XXX
            g.fillRect(startx +sqlength+3, starty, sqlength, sqlength);
            g.fillRect(startx+3, starty+sqlength, sqlength*3, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty+sqlength,
                       sqlength, sqlength);
         break;
         case 2:
            // XX
            //  XX
            g.fillRect(startx +3, starty, sqlength*2, sqlength);
            g.fillRect(startx+sqlength+3, starty+sqlength,
                       sqlength*2, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3, starty, sqlength, sqlength);
            g.drawRect(startx+sqlength+3, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty+sqlength, sqlength, sqlength);
         break;
         case 3:
            //  XX
            // XX
            g.fillRect(startx +sqlength+3, starty, sqlength*2, sqlength);
            g.fillRect(startx+3, starty+sqlength, sqlength*2, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
            g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty+sqlength, sqlength, sqlength);
         break;
         case 4:
            //  XX
            //  XX
            g.fillRect(startx +sqlength+3, starty, sqlength*2, sqlength*2);
            this.setBlockColor(g, 0);
            g.drawRect(startx +sqlength+3, starty, sqlength*2, sqlength*2);
            g.drawLine(startx +sqlength*2+3, starty,
                       startx +sqlength*2+3, starty+sqlength*2);
            g.drawLine(startx +sqlength+3, starty+sqlength,
                       startx +sqlength*3+3, starty+sqlength);
         break;
         case 5:
            //  XXX
            //    X
            g.fillRect(startx +3, starty, sqlength*3, sqlength);
            g.fillRect(startx+sqlength*2+3, starty+sqlength,
                       sqlength, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty+sqlength,
                       sqlength, sqlength);
         break;
         case 6:
            //  XXX
            //  X
            g.fillRect(startx +3, starty, sqlength*3, sqlength);
            g.fillRect(startx+3, starty+sqlength, sqlength, sqlength*1);
            this.setBlockColor(g, 0);
            g.drawRect(startx+3, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength, starty, sqlength, sqlength);
            g.drawRect(startx+3+sqlength*2, starty, sqlength, sqlength);
            g.drawRect(startx+3, starty+sqlength, sqlength, sqlength);
         break;
      }
   }

   //  ׸   Ѵ.
   public void setBlockColor(Graphics g, int color) {
      switch(color) {
         case 0: g.setColor(255,255,255);    break;			
/*
         case 1: g.setColor(255,0,0);        break;			
         case 2: g.setColor(0,200,0);        break;
         case 3: g.setColor(0,200,255);      break;
         case 4: g.setColor(255,255,0);      break;
         case 5: g.setColor(255,150,0);      break;
         case 6: g.setColor(210,0,240);      break;
         case 7: g.setColor(40,0,240);       break;                      
         case 8: g.setColor(0,0,0);          break;
*/
         default : g.setColor(0,0,0);        break;
      }
   }

   public void keyPressed(int keycode) {
      int action = getGameAction(keycode);

      switch(action) {
         case FIRE:
         break;			
         case LEFT:                 //  ȭǥ
            moveCurrPiece(-1, 0, false);        //   ̵
            needNewPiece = false;
            repaint();
         break;
         case RIGHT:                //  ȭǥ
            moveCurrPiece(1, 0, false);         //   ̵
            needNewPiece = false;
            repaint();
         break;
         case UP:                   //  ȭǥ
            if(curWhat != 4) {
               moveCurrPiece(0, 0, true);       //  ȸŴ
               repaint();
            }
         break;
         case DOWN:                 // Ʒ ȭǥ
            while(moveCurrPiece(0, -1, false)); //   ߸
            repaint();
         break;

      }
   }

   // Ÿ ϱ  update() ޼ҵ带  Ͽ.
   public void update(Graphics g) {
      justUpdating = true;
      paint(g);
   }
   
   // Ȳ ° Ʈ ȭ ׷ش.
   public synchronized void paint(Graphics g) {
      try {
         if(isStart) {
            g.setFont(Font.getFont(Font.FACE_SYSTEM,Font.STYLE_ITALIC ,Font.SIZE_MEDIUM));
            g.drawString("JAVA TETRIS",10, 40, 20);
            g.drawRect(0,0,95,99);
         } else {
            // Ʈ    ϰ, ü  .
            this.setBlockColor(g, 0);
            g.fillRect(0,0,95,99);

            //  κ ׷ش.
            this.setBlockColor(g, 8);
            g.drawRect(0,0,95,99);
            g.drawRect(xoffset-1, 2, sqlength*cols+1, sqlength*rows+1);

            //   Ȳ ׷ش.
            this.setBlockColor(g, 8);
            g.setFont(Font.getFont(Font.FACE_SYSTEM,Font.STYLE_PLAIN,Font.SIZE_SMALL));
            g.drawString("Score", 3, 40, 20);
            g.drawString(""+score, 3, 55, 20);
            g.drawString("Level", 3, 70, 20);
            g.drawString(""+level, 3, 85, 20);

            //  Ʈ  ׸.
            this.drawNextPiece(g);

            // ʿ  Ʈ  ׸.
            //    ϸ鼭
            // ο Ȳ ǰ  Ȳ  ٸ 쿡
            // ׷ ν ӵ ϰ ִ.
            for(int i=0; i<cols; i++) {
               for(int j=0; j<rows; j++) {
                  if((!justUpdating)||
                     (of[i][rows-1-j] == -1)||
                     (of[i][rows-1-j] != f[i][rows-1-j])) {
                     // Ʈ    ׷ش.
                     this.setBlockColor(g, f[i][rows-1-j]);		    	    
                     g.fillRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);

                     // Ʈ    ׵θ ׷ش.
                     this.setBlockColor(g, 0);
                     g.drawRect(xoffset+sqlength*i, 3+sqlength*j, sqlength, sqlength);
                  }
                  //      Ѵ.
                  of[i][rows-1-j] = f[i][rows-1-j];
               }
            }
            justUpdating = false;
         }
      } catch(Exception e) {
         System.out.println(e.getMessage());
         System.out.println(e.toString());
      }
   }
}
