/**
 * Server α׷ J2ME CLDC/MIDP   
 * DatagramConnection û ޾  Ʈ  α׷
 */

import java.io.*;
import java.net.*;

public class DatagramConnectionServer 
{
 private DatagramSocket recei = null; // receive DatagramSocket
 private DatagramSocket send = null;  // send DatagramSocket

 private DatagramPacket rPacket = null; // receive DatagramPacket
 private DatagramPacket sPacket = null; // send DatagramPacket

 private final static int port = 9000;  // Server Port Number

 public DatagramConnectionServer()
 {
  try
  {
    // receive DatagramSocket 
    recei = new DatagramSocket(port);
    
	// Client  DatagramPacket 
	byte[] buffer = new byte[128];
    rPacket = new DatagramPacket( buffer, buffer.length );
    recei.receive(rPacket);
    
	//  DatagramPacket ̿ Data reverse
    String output = (new StringBuffer((new String(rPacket.getData())).trim())).reverse().toString();
	byte[] out = output.getBytes();
    
	// Client  DatagramPacket 
    int sPort = rPacket.getPort();
    InetAddress sAddress = rPacket.getAddress();
    sPacket = new DatagramPacket( out, out.length, sAddress, sPort );
    
	//  DatagramPacket Client 
	send = new DatagramSocket();
    send.send( sPacket );
  }
  catch (IOException e) 
  {
   System.err.println("Exception caught:" + e);
  }
  finally 
  {
   try { 
    if(rPacket != null) rPacket = null;
    if(sPacket != null) sPacket = null;
    if(send != null) send.close();
    if(recei != null) recei.close();
   }catch (Exception e) {}
  }
 }	
 
 public static void main(String[] args){
  new DatagramConnectionServer();
 }
}