/**
 * HTTP GET ޼ҵ û 
 * Servlet ID, PASSWORD  α ϴ  
 */

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class HttpGetMIDlet extends MIDlet implements CommandListener, Runnable
{
 private Display display;        // ÷ ü
 private Form mainForm;          //  Form 
 private Form waitForm;          // wait Form
 private TextField idField;      // id TextField
 private TextField pwField;      // password TextField
 private Command connectCommand; // connect Command
 private Command exitCommand;    // exit Command

 private HttpConnection hc = null; // HttpConnection ü 
 private InputStream in = null;    // InputStream ü 
 
 //  Servlet URL
 private String url = "http://127.0.0.1/servlet/HttpGetServlet";

 public void startApp() 
 {
  // ÷ ü 
  display = Display.getDisplay(this);

  // main, wait Form ʱȭ
  mainForm = new Form("HTTP Get MIDlet");
  waitForm = new Form("Waiting...");
  
  // id, password TextField ʱȭ
  idField = new TextField("ID :", "", 10, TextField.NUMERIC);
  pwField = new TextField("PASSWORD:", "", 10, TextField.ANY | TextField.PASSWORD);        

  // Command 
  connectCommand = new Command("Connect", Command.SCREEN, 0);
  exitCommand = new Command("Exit", Command.EXIT, 0);
 
  // idField, pwField mainForm  
  mainForm.append(idField);
  mainForm.append(pwField);

  // Command 
  mainForm.addCommand(connectCommand);
  mainForm.addCommand(exitCommand);
  
  // Listener, Current 
  mainForm.setCommandListener(this);
  display.setCurrent(mainForm);
 }

 public void commandAction(Command c, Displayable s)
 {
  if (c == exitCommand)
  {
   notifyDestroyed();
  }
  // Servlet  ϶!!!
  else if(c == connectCommand)
  {
   display.setCurrent(waitForm);
   Thread t = new Thread( this );
   t.start();
  }
 }
 
 public void run()
 {
   connect();
 }

 private void connect() 
 {
  String queryString = "";
  try 
  {
   // GET û  queryString 
   queryString = "?" + "id=" + idField.getString() + "&" + 
                 "password=" + pwField.getString();
   // HTTP Connection 
   hc = (HttpConnection)Connector.open(url + queryString);
   // RequestMethod GET 
   hc.setRequestMethod(HttpConnection.GET); 

   // InputStream 
   in = hc.openInputStream();
   //   Ÿ 
   int length = (int)hc.getLength();
   byte[] raw = new byte[length];
   in.read(raw);

   //  Ÿ 
   String output = new String(raw);
   Alert alert = new Alert("Server Response", output, null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, mainForm);
  }
  catch (IOException e) 
  {
   Alert alert = new Alert("Exception", e.toString(), null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, mainForm);
  }
  finally
  {
   try { 
	if(in != null) in.close();
	if(hc != null) hc.close();
   } catch (IOException ioe) {}
  }
 }

 public void pauseApp() {}

 public void destroyApp(boolean unconditional) {}
}
