/**
 * HTTP HEAD ޼ҵ û 
 * Server Head   α׷ 
 */

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class HttpHeadMIDlet extends MIDlet implements CommandListener, Runnable
{
 private Display display;        // ÷ ü
 private Form mainForm;          //  Form 
 private Form waitForm;          // wait Form
 private TextField urlField;     // url TextField
 private Command connectCommand; // connect Command
 private Command exitCommand;    // exit Command

 private HttpConnection hc = null; // HttpConnection ü

 //  Server URL
 private String url = "http://127.0.0.1/";
  
 public void startApp() 
 {
  // ÷ ü 
  display = Display.getDisplay(this);

  // main, wait Form ʱȭ
  mainForm = new Form("HTTP Head MIDlet");
  waitForm = new Form("Waiting...");

  // url TextField ʱȭ
  urlField = new TextField(null, url, 100, TextField.URL);

  // Command 
  connectCommand = new Command("Connect", Command.SCREEN, 0);
  exitCommand = new Command("Exit", Command.EXIT, 0);

  // mainForm 
  mainForm.append(urlField);
  // Command 
  mainForm.addCommand(connectCommand);
  mainForm.addCommand(exitCommand);
  
  // Listener, Current 
  mainForm.setCommandListener(this);
  display.setCurrent(mainForm);
 }

 public void commandAction(Command c, Displayable s)
 {
  if (c == exitCommand)
  {
   notifyDestroyed();
  }
  // Servlet  ϶!!!
  else if(c == connectCommand)
  {
   display.setCurrent(waitForm);
   Thread t = new Thread( this );
   t.start();
  }
 }
 
 public void run()
 {
   connect();
 }

 private void connect() 
 {
  String output = "";
  try 
  {
   //  Server URL 
   url = urlField.getString();
   // HTTP Connection 
   hc = (HttpConnection)Connector.open(url);
   // RequestMethod HEAD 
   hc.setRequestMethod(HttpConnection.HEAD);

   // Server  type, length  
   output = output + "type : " + hc.getType() + "\n"
                   + "length : " + hc.getLength()+ "\n" ;

   //  Ÿ 
   Alert alert = new Alert("Server Response", output, null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, mainForm);
  }
  catch (IOException e) 
  {
   Alert alert = new Alert("Exception", e.toString(), null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, mainForm);
  }
  finally
  {
   try { 
	if(hc != null) hc.close();
   } catch (IOException ioe) {}
  }
 }

 public void pauseApp() {}

 public void destroyApp(boolean unconditional) {}
}
