/**
 * HTTP POST ޼ҵ û 
 * Servlet UpperCase ٲ String POST    
 */

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class HttpPostMIDlet extends MIDlet implements CommandListener, Runnable
{
 private Display display;        // ÷ ü
 private Form waitForm;          // wait Form
 private TextBox textBox;        // TextBox ü
 private Command connectCommand; // connect Command
 private Command exitCommand;    // exit Command

 private HttpConnection hc = null;    // HttpConnection ä 
 private DataOutputStream out = null; // DataOutputStream ü
 private InputStream in = null;       // InputStream ü 

 //  Servlet URL
 private String url = "http://127.0.0.1/servlet/HttpPostServlet";
  
 public void startApp() 
 {
  // ÷ ü 
  display = Display.getDisplay(this);

  // textBox, wait Form ʱȭ
  textBox = new TextBox("Http Post MIDlet", "UpperCase String", 100, TextField.ANY);
  waitForm = new Form("Waiting...");

  // Command 
  connectCommand = new Command("Connect", Command.SCREEN, 0);
  exitCommand = new Command("Exit", Command.EXIT, 0);

  // Command 
  textBox.addCommand(connectCommand);
  textBox.addCommand(exitCommand);
  
  // Listener, Current 
  textBox.setCommandListener(this);
  display.setCurrent(textBox);
 }

 public void commandAction(Command c, Displayable s)
 {
  if (c == exitCommand)
  {
   notifyDestroyed();
  }
  // Servlet  ϶!!!
  else if(c == connectCommand)
  {
   display.setCurrent(waitForm);
   Thread t = new Thread( this );
   t.start();
  }
 }
 
 public void run()
 {
   connect();
 }

 private void connect() 
 {
  try 
  {
   // û Ʈ 
   String requeststring = "text=" + textBox.getString();
   // HTTP Connection 
   hc = (HttpConnection)Connector.open(url, Connector.READ_WRITE);
   // RequestMethod POST 
   hc.setRequestMethod(HttpConnection.POST);

   //   Ÿ ޱ  outputStream 
   out = hc.openDataOutputStream();
   //  û Ʈ .
   byte[] request = requeststring.getBytes();
   for (int i = 0; i < request.length; i++)
   {
    out.writeByte(request[i]);
   }
   out.flush();

   // InputStream 
   in = hc.openInputStream();
   //   Ÿ 
   int length = (int)hc.getLength();
   byte[] raw = new byte[length];
   in.read(raw);

   //  Ÿ 
   String output = new String(raw);
   Alert alert = new Alert("Server Response", output, null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, textBox);
  }
  catch (IOException e) 
  {
   Alert alert = new Alert("Exception", e.toString(), null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, textBox);
  }
  finally
  {
   try { 
	if(out != null) out.close();
	if(in != null) in.close();
	if(hc != null) hc.close();
   } catch (IOException ioe) {}
  }
 }

 public void pauseApp() {}

 public void destroyApp(boolean unconditional) {}
}
