@rem ***************************************************************
@rem ** Copyright 1999, 2000 Motorola, Inc. All rights reserved.
@rem **
@rem ** compileAll.bat
@rem **
@rem ** Assumptions:
@rem **   - Current directory is the src directory
@rem **     where this batch file is located.
@rem **   - Demo apps are in the package com\mot\j2me\midlets
@rem **   - The directories libmidlets\com\mot\j2me\midlets and
@rem **     libmidlets\com\mot\j2me\midlets are created.
@rem **   - Java 1.2 compiler can be invoked:
@rem **     + javac.exe is on the PATH
@rem **
@rem ** Results:
@rem **   - compiled and preveriified classes will be created under
@rem **     the following directories:
@rem ** 
@rem **     libmidlets\com\mot\j2me\midlets\bounce
@rem **     libmidlets\com\mot\j2me\midlets\imagetests
@rem **     libmidlets\com\mot\j2me\midlets\paddleball
@rem **     libmidlets\com\mot\j2me\midlets\scribble
@rem **     libmidlets\com\mot\j2me\midlets\tests
@rem **     libmidlets\com\mot\j2me\midlets\tutorials
@rem **
@rem ***************************************************************

@if NOT "%1"=="" set COMPILECLASS=%1
@if     "%1"=="" set COMPILECLASS=com\mot\j2me\midlets\bounce\*.java com\mot\j2me\midlets\imagetests\*.java com\mot\j2me\midlets\paddleball\*.java com\mot\j2me\midlets\scribble\*.java com\mot\j2me\midlets\tests\*.java com\mot\j2me\midlets\tutorials\*.java


@echo Compiling ...
@echo off

javac -O -d ..\libmidlets -bootclasspath ..\lib %COMPILECLASS%

@echo Preverifying ...
@echo off
..\preverifier\preverifier -classpath ..\lib -d ..\libmidlets ..\libmidlets










