/******************************************************************************
	ImgModeTest.java
		 : ̹  ׽Ʈ
		 :   ư  Į 尡 ȴ.
*******************************************************************************/

package graphic;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.xce.lcdui.*;
import com.skt.m.*;

public class ImgModeTest extends MIDlet implements CommandListener
{
    Display display;
	Canvas testCanvas;

	Command exitComm = new Command("Exit", Command.EXIT, 0);
	Command grayComm = new Command("4 GrayMode", Command.SCREEN, 1);
	Command color1Comm = new Command("256 ColorMode", Command.SCREEN, 2);
	Command color2Comm = new Command("64K ColorMode", Command.SCREEN, 3);
	
    public ImgModeTest()
    {
		testCanvas = new TestCanvas();
    }

    public void startApp()
    {
		testCanvas.addCommand(exitComm);
		testCanvas.addCommand(grayComm);
		testCanvas.addCommand(color1Comm);
		testCanvas.addCommand(color2Comm);
		testCanvas.setCommandListener(this);
    	
    	display = Display.getDisplay(this);
        display.setCurrent(testCanvas);
    }

    public void destroyApp(boolean uncond)
    {
    }

    public void pauseApp()
    {
    }

    class TestCanvas extends Canvas {
        Image image;

        public TestCanvas() {
        }

        public void paint(Graphics g) {
			g.setColor(Toolkit.white);
			g.fillRect(0, 0, this.getWidth(), this.getHeight());
            try {
				image = Image.createImage("/graphic/color.png");
            } catch (java.io.IOException ex) {}
            g.drawImage(image, 0, 0, Graphics.TOP | Graphics.LEFT);
        }
    }

	public void commandAction(Command c, Displayable d) {
		if (c == grayComm && System.getProperty("m.SKT_API") == null){
			Device.setColorMode(Device.COLOR_MODE_4G);
			testCanvas.repaint();
		} else if (c == color1Comm && System.getProperty("m.SKT_API") == null) {
			Device.setColorMode(Device.COLOR_MODE_256C);
			testCanvas.repaint();
		} else if (c == color2Comm && System.getProperty("m.SKT_API") == null) {
			Device.setColorMode(Device.COLOR_MODE_64KC);
			testCanvas.repaint();
		} else if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		}
	}
}
