/******************************************************************************
	TransTest.java
		 : ̹ ׽Ʈ
		 :  ư   Ǹ ̹ Ȯ
*******************************************************************************/

package graphic;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.xce.lcdui.*;

public class TransTest extends MIDlet implements CommandListener
{
    Display display;
	Canvas testCanvas;
	int bgColor;

	Command exitComm = new Command("Exit", Command.EXIT, 0);
	Command testComm = new Command("", Command.SCREEN, 1);

    public TransTest()
    {
		testCanvas = new TestCanvas();
		bgColor = Toolkit.WHITE;
    }

    public void startApp()
    {
		testCanvas.addCommand(exitComm);
		testCanvas.addCommand(testComm);
		testCanvas.setCommandListener(this);
    	
    	display = Display.getDisplay(this);
        display.setCurrent(testCanvas);
    }

    public void destroyApp(boolean uncond)
    {
    }

    public void pauseApp()
    {
    }

    class TestCanvas extends Canvas {
        Image image;

        public TestCanvas() {
            try {
				image = Image.createImage("/graphic/" + this.getWidth()+ (this.getHeight() + 16) + "ntop.png");
            } catch (java.io.IOException ex) {
				try {
					image = Image.createImage("/graphic/ntop.png");
				} catch (Exception e2) {
				}
            }
			
			// FIXME
			if (image.getWidth() == 10) {
				try {
					image = Image.createImage("/graphic/ntop.png");
				} catch (Exception e2) {
				}
			}
        }

        public void paint(Graphics g) {
        	//    ä
			g.setGrayScale(bgColor);
			g.fillRect(0, 0, this.getWidth(), this.getHeight());
			// ̹ ׸
            g.drawImage(image, 0, 0, Graphics.TOP | Graphics.LEFT);
        }
    }

	public void commandAction(Command c, Displayable d) {
		if (c == testComm) {
			if( bgColor == Toolkit.WHITE ){
				bgColor = Toolkit.BLACK;
			}
			else{
				bgColor = Toolkit.WHITE;
			}
				
		} else if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		}
	}

}
