package skvm;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.xce.lcdui.*;
import com.skt.m.*;

public class Divide4 extends MIDlet implements CommandListener{
	private Command exitComm = new Command("Exit", Command.EXIT, 0);
	private Command modeComm = new Command("True/False", Command.SCREEN, 1);
	private Divide4Canvas d4c = new Divide4Canvas(this);
	private boolean isRestore = false;

	public void startApp() {
		d4c.addCommand(exitComm);	
		d4c.addCommand(modeComm);
		d4c.setCommandListener(this);
		Display.getDisplay(this).setCurrent(d4c);
	}
	
	public void pauseApp() {
	}
	
	public void destroyApp(boolean unconditinoal) {
	}

	public void commandAction(Command c, Displayable d) {
		if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		} else if( c == modeComm){
			isRestore = !isRestore;
			Device.enableRestoreLCD(isRestore);
		}
	}


class Divide4Canvas extends Canvas implements Runnable {
	int index;
	Divide4 midlet;
	Display display;
	int width;
	int height;
	
	Image img;
	
	public Divide4Canvas(Divide4 midlet) {
		try {
			img = Image.createImage("/skvm/color.png");
		} catch (Exception e) {
		}
		
		this.midlet = midlet;
		display = Display.getDisplay(midlet);
		display.callSerially(this);
		width = getWidth() / 2;
		height = (getHeight() + 16) / 2;		
	}
	
	public void paint(Graphics g) {
		int x = 0;
		int y = 0;
		switch (index) {
			case 0:
				x = 0;
				y = 0;
				break;
			case 1:
				x = width;
				y = 0;
				break;
			case 2:
				x = width;
				y = height;
				break;
			case 3:
				x = 0;
				y = height;
				break;			
		}
		g.setClip(x, y, width, height);
		g.drawImage(img, 0, 0, Graphics.LEFT | Graphics.TOP);
		display.callSerially(this);
		
		g.setColor(Toolkit.black);
		g.drawString(String.valueOf(isRestore), 0, 0, Graphics.TOP | Graphics.LEFT);
		try {
			Thread.sleep(500);
		} catch (Exception e) {
		}
	}
	
	public void run() {
		index++;
		if (index == 4) {
			index = 0;
		}
		this.repaint(0, 0, XDisplay.width, XDisplay.height2);
	}
	
}

}
