package skvm;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import com.xce.io.*;
import com.xce.lcdui.*;
import com.xce.util.*;

public class FileTest2 extends MIDlet implements CommandListener{
	Display display; 
	Form form = new Form("FileTest");
	StringItem sItem = new StringItem(null, "");
	TextField tfSize = new TextField("׽Ʈ뷮 :", "", 10, TextField.NUMERIC);
	static final Command exitCmd = new Command("", Command.EXIT, 1);
	static final Command runCmd = new Command("", Command.OK, 2);
	FileCanvas filecanvas;

	public FileTest2(){
		form.append(sItem);
		form.append(tfSize);
		form.addCommand(exitCmd);
		form.addCommand(runCmd);
		form.setCommandListener(this);
		
		sItem.setText("밡ɿ뷮:\n" + XFile.fsavail() + "\n");	
		tfSize.setString(String.valueOf(XFile.fsavail()));
		
		display = Display.getDisplay(this);	
	}

	public void startApp() {
		display.setCurrent(form);
	}

	public void commandAction(Command c, Displayable d) {
		if (c == runCmd) {
			filecanvas = new FileCanvas(this, Long.parseLong(tfSize.getString()) );
			filecanvas.addCommand(exitCmd);
			filecanvas.testStart();
			display.setCurrent(filecanvas);
		} else if (c == exitCmd) {
			destroyApp(true);
		}
	}
	
	public void pauseApp() {
	}
	
	public void destroyApp(boolean unconditional) {
		notifyDestroyed();
	}


class FileCanvas extends Canvas implements Runnable{

	FileTest2 midlet;
	Display display;
	int initAvail;
	int avail;
	long count;
	long maxSize;
	
	public FileCanvas(FileTest2 midlet, long size) {		
		this.midlet = midlet;
		this.maxSize = size;
		setCommandListener( midlet );
		
		initAvail = XFile.fsavail();
	}

	public void testStart(){
		new Thread(this).start();
	}
	
	public void paint(Graphics g) {
		avail = XFile.fsavail();
		g.setColor(Toolkit.white);
		g.fillRect(0, 0, getWidth(), getHeight());
		g.setColor(Toolkit.black);
		g.drawString("before : " + initAvail, 0, 0, Graphics.TOP | Graphics.LEFT);
		g.drawString("now : " + avail, 0, 20, Graphics.TOP | Graphics.LEFT);
		g.drawString("Write : " + count, 0, 40, Graphics.TOP | Graphics.LEFT);
	}

	
	public void run() {
		FileOutputStream out = null;
		count = 0;
		try {
			out = new FileOutputStream("filetest");
			byte[] buf = new byte[1024];
			
			while (true) {
				int size = (int)((maxSize-count) > 1024 ? 1024: (maxSize-count));
				out.write(buf, 0, size);
				count += size;
				this.repaint();	
			}
		} catch (Exception e) {
			com.xce.util.Debug.debugOut("count : " + count);
		} finally {
			if (out != null) {
				try {
					out.close();
				} catch (Exception e) {
				}
			}
			try {
				if( XFile.exists("filetest") ){
					XFile.unlink("filetest");
				}
			} catch (Exception e) {
			}
		}
	}
	
	public void keyPressed(int keyCode) {
		synchronized(this) {
			try {
				wait(1000);
			} catch (Exception e) {
			}
		}
	}
}


}
