/******************************************************************************
	ParamTest.java
		 : System Property  Ȯ
		 :  ޴ Ͽ  ý  Ȯ
*******************************************************************************/

package skvm;

import com.skt.m.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class ParamTest extends MIDlet
			implements CommandListener {
    Display display;
    int skvmVersion = 0;
	
	Command exitComm = new Command("Exit", Command.EXIT, 0);
	Command okComm = new Command("OK", Command.OK, 1);
	
	List testList = new List("System Param Test", List.IMPLICIT);
	
	String Title[] = {"ܸ ","ܸ H/W ","LCD ","SK-VM ÷ ","ġ ","Ÿ"};
	String list0[][] = {{"","m.CARRIER"},
						{"ܸ Ÿ","m.TYPE"},
						{"ü","m.VENDER"},
						{"𵨸","m.MODEL"}};
	String list1[][] = {{" ","m.SOUND_POLY"}};
	String list2[][] = {{"LCD size","m.LCD_PIXEL"},
						{"Font size","m.LCD_FONT"},
						{" color","m.COLOR"}};
	String list3[][] = {{"Conf/Prof","m.CONF_PROFILE"},			//SK-VM 1.0
						{"ConfVer","m.CONF_VER"},
						{"ProfVer1","m.PROFILE_VER1"},
						{"ProfVer2","m.PROFILE_VER2"},
						{"SKT-API Ver", "m.SKT_API"},
						{"JAM Ver", "m.APP_MANAGER"},
						{"PLIB", "m.PLIB_RELEASE"}};
	String list3_1[][] = {{"Conf/Prof","m.CONF_PROFILE"},		//SK-VM 1.1
						  {"SK-VM","m.SK_VM"},
						  {"EXT S/W","m.EXT_SW"},
						  {"PLIB", "m.PLIB_RELEASE"}};
	String list4[][] = {{"ȭȣ","m.MIN"},
						{"BASE_ID","m.BASE_ID"},
						{"REG_ZONE","m.REG_ZONE"},
						{"PILOT_PN","m.PILOT_PN"},
						{"NID","m.NID"},
						{"SID","m.SID"}};

	public ParamTest() {
		testList.addCommand(exitComm);
		testList.addCommand(okComm);
		testList.setCommandListener(this);
		
		for(int i=0; i<Title.length; i++)
			testList.append(Title[i], null);
			
		if(	System.getProperty("m.SK_VM") != null ){
			skvmVersion = 1;
		}			
		
		display = Display.getDisplay(this);
	}
	
    public void startApp () {
        display.setCurrent(testList);
	}
	
    public void destroyApp (boolean unconditional) {
    }

    public void pauseApp () {
    }
	
	public void commandAction(Command c, Displayable d) {
		if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == okComm || c == List.SELECT_COMMAND){
			viewInfo(testList.getSelectedIndex());
		}
	}
	
	private void viewInfo(int testnum){
		String temp[][] = null;		
		String info="";

		switch(testnum){
			case 0:
				temp = list0;
				break;
			case 1:
				temp = list1;
				break;
			case 2:
				temp = list2;
				break;
			case 3:
				if( skvmVersion == 0 ){
					temp = list3;
				}else if( skvmVersion == 1 ){
					temp = list3_1;
				}
				break;
			case 4:
				temp = list4;
		}
		
		if( temp != null ){
			// ý  ϱ : String getProperty(String key)
			for( int i=0; i<temp.length; i++ )
				info += temp[i][0] + " : " + System.getProperty(temp[i][1]) + "\n";
			
			alert(Title[testnum],info);
		} else if( testnum == 5 ) {
			Runtime rt = Runtime.getRuntime();
			info = "-  ޸\n" + rt.totalMemory() + "\n\n- 밡 ޸\n" + rt.freeMemory();			
			alert(Title[testnum], info);
		}
	}
	
	private void alert(String name, String msg){
		Alert alert = new Alert(name);
		alert.setString(msg);
		alert.setTimeout(Alert.FOREVER);
		display.setCurrent(alert);
	}
	
}
