/**
 *
 * @(#)ImplicitlyTrustedClass.java	1.1 01/08/02
 *
 * Copyright 2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 */

package com.sun.midp.security;

/**
 * Enables optional dynamically loaded implicitly trusted classes to be given
 * security domains.
 */
public interface ImplicitlyTrustedClass {
    /**
     * Initializes the security domain for this class, so it can
     * perform actions that a normal MIDlet Suite cannot.
     *
     * @param domain <code>SecurityDomain</code> for this class.
     */
    public void initSecurityDomain(SecurityDomain domain);
}
