# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgagent.mk	1.9 98/11/13
#
# Makefile for the shared part of the debug agent.

include pkgagent_$(PLATFORM).mk

####################
# exported variables
####################

DEFINES		+= -DBREAKPTS
CLASSES		+= $(AGENTCLASSES)
JNIHEADERCLASSES+= $(AGENTJNIHEADERCLASSES)
OPTIONALSRCDIRS	+= $(OPTIONALSHARESRCDIR)/javafile

ifeq ($(STATICLIBRARIES), true)
SHAREOBJECTS	+= $(AGENTSHAREOBJECTS)
endif


#################
# classes
#################

AGENTJNIHEADERCLASSES = \
	sun.tools.agent.Agent \
	sun.tools.agent.AgentConstants \
	sun.tools.agent.Breakpoint \
	sun.tools.agent.CachedClass \
	sun.tools.agent.CachedField \
	sun.tools.agent.CachedMethod \
	sun.tools.agent.MainThread \
	sun.tools.agent.StackFrame \
	sun.tools.java.Constants

AGENTCLASSES = \
	sun.tools.agent.Agent \
	sun.tools.agent.EmptyApp \
	sun.tools.java.RuntimeConstants


###############
# objects
###############

AGENTSHAREOBJECTS = agent.o
