# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkghprof.mk	1.1 98/11/11
#
# Makefile for the hprof shared library.

include pkghprof_$(PLATFORM).mk

####################
# exported variables
####################

ifeq ($(STATICLIBRARIES), true)
SHAREOBJECTS	+= $(HPROFSHAREOBJECTS) $(HPROFPLATFORMOBJECTS)
endif


###############
# objects
###############

HPROFSHAREOBJECTS += \
	hprof.o \
	hprof_class.o \
	hprof_cpu.o \
	hprof_gc.o \
	hprof_hash.o \
	hprof_heapdump.o \
	hprof_io.o \
	hprof_jni.o \
	hprof_listener.o \
	hprof_method.o \
	hprof_monitor.o \
	hprof_name.o \
	hprof_object.o \
	hprof_setup.o \
	hprof_site.o \
	hprof_thread.o \
	hprof_trace.o \
