# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)GNUmakefile_win32.mk	1.16 98/10/13
#
# win32 specific targets.

######################
# pjavaw target
######################

$(APPLICATION) :: $(PJAVABIN)/$(APPLICATION)w$G$(EXE)

$(PJAVABIN)/$(APPLICATION)w$G$(EXE) :: $(OBJ)/javaw.o $(PJAVALIBS) $(PJAVAEXTRAS)
	@echo "... Linking $@"
	@$(LINKPJAVA) $(LINKOUT)$@ $^ $(LINKPJAVAFLAGS) $(PJAVALINKLIBS)


######################
# pappletviewer target
######################

ifeq ($(APPLICATION),pjava)

$(APPLICATION) :: $(PJAVABIN)/pappletviewer$G$(EXE)

$(PJAVABIN)/pappletviewer$G$(EXE) :: \
		$(OBJ)/appletviewer.o $(PJAVALIBS) $(PJAVAEXTRAS)
	@echo "... Linking $@"
	@$(LINKPJAVA) $(LINKOUT)$@ $^ $(LINKPJAVAFLAGS) $(PJAVALINKLIBS)

endif


##################
# some clean rules
##################

cleanasmloop :
	rm -rf build/executeJava* build/fj* build/opcodes.*

clean:: cleanasmloop
	rm -rf build/*.exe build/*.pdb build/*.map
	rm -rf build/awt_colors.h
