# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)javai_win32.mk	1.11 98/10/21
#
# List of win32 classes to compile and run javah on and list
# of files to link with javai.

####################
# exported variables
####################

JAVAIPLATFORMOBJECTS	+= $(JAVAIWIN32OBJECTS)
JAVAILINKLIBS 		= winmm.lib advapi32.lib
ifeq ($(SUPPORTPROFILER), true)
JAVAILINKLIBS		+= wsock32.lib
endif
JAVAIEXPORTS 		= @exports_javai.lcf
ifeq ($(JVMDI), true)
JAVAIEXPORTS		+= @exports_debugger.lcf
endif

ASMLOOPPROCESSOR	= p5


#################
# classes
#################

JAVAISTUBCLASSES += \
	java.lang.Win32Process \
	\
	sun.audio.AudioDevice

JAVAIPLATFORMCLASSES = \
	java.lang.Win32Process \
	\
	sun.audio.AudioDevice \
	sun.audio.AudioTranslatorStream \
	sun.audio.NativeAudioStream


###############
# objects
###############

JAVAIWIN32OBJECTS = \
	condvar_md.o \
	dirent.o \
	fd_md.o \
	gc_md.o \
	invokeNative_x86.o \
	io_md.o \
	javai.o \
	linker_md.o \
	math_md.o \
	memory_md.o \
	monitor_md.o \
	path_md.o \
	system_md.o \
	threads_md.o \
	\
	audio.o 

ifndef FILTERAPP
JAVAIWIN32OBJECTS += \
	sun_audio_AudioDevice_audioClose.o \
	sun_audio_AudioDevice_audioOpen.o \
	sun_audio_AudioDevice_audioWrite.o \
	\
	java_lang_Win32Process_close.o \
	java_lang_Win32Process_create.o \
	java_lang_Win32Process_destroy.o \
	java_lang_Win32Process_exitValue.o \
	java_lang_Win32Process_waitFor.o \
	\
	java_lang_Runtime_execInternal.o \
	\
	java_lang_System_initProperties.o
endif

ifeq ($(NOAWT),true)
JAVAIWIN32OBJECTS += \
	null_awt.o
endif
