/*
 * @(#)TouchableVirtualKeySet.java	1.3 98/10/30 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
   
package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.*;
import java.util.Locale;

public class TouchableVirtualKanaKeySet extends TouchableVirtualKeySet {

    
    static final int DAKUTEN_MODE = 1 << 5;
    static final int HANDAKUTEN_MODE = 1 << 6;
    static final int SHOUJI_MODE = 1 << 7;
    static final int KATAKANA_MODE = 1 << 8;

    static final int KATAKANA_OFFSET = 0x60;


    public TouchableVirtualKanaKeySet(VirtualKeyboardModel vkModel,
				      ObjectToolkit toolkit, 
				      ContainerView parent,
				      Rectangle bounds,
				      Color bgColor,
				      String keySetResource) {
	super(vkModel, toolkit, parent, bounds, bgColor, keySetResource);
    }

    public TouchableVirtualKanaKeySet(VirtualKeyboardModel vkModel,
				      ObjectToolkit toolkit, 
				      ContainerView parent,
				      Rectangle bounds,
				      Color bgColor,
				      String keySetResource, Locale locale) {
	super(vkModel, toolkit, parent, bounds, bgColor, keySetResource, locale);
    }
}


