/* 
 * @(#)java_lang_Character_getY.c	1.1 98/08/28
 * 
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

#include <java_lang_Character.h>
#include <stdio.h>

/* 
 * The static final arrays of bytes that make up the X and Y arrays of
 * java.lang.Character.
 * 
 * This C file saves us the extra static initializer space for that class
 */

static HArrayOfByte Yhandle;

static const unsigned char Y[7808] = {
      0,   0,   0,   0,   0,   0,   0,   0,  /*   0 */
      0,   1,   1,   1,   1,   1,   0,   0,  /*   0 */
      0,   0,   0,   0,   0,   0,   0,   0,  /*   0 */
      0,   0,   0,   0,   1,   1,   1,   1,  /*   0 */
      2,   3,   3,   3,   4,   3,   3,   3,  /*   0 */
      5,   6,   3,   7,   3,   8,   3,   3,  /*   0 */
      9,   9,   9,   9,   9,   9,   9,   9,  /*   0 */
      9,   9,   3,   3,   7,   7,   7,   3,  /*   0 */
      3,  10,  10,  10,  10,  10,  10,  10,  /*   1 */
     10,  10,  10,  10,  10,  10,  10,  10,  /*   1 */
     10,  10,  10,  10,  10,  10,  10,  10,  /*   1 */
     10,  10,  10,   5,   3,   6,  11,  12,  /*   1 */
     11,  13,  13,  13,  13,  13,  13,  13,  /*   1 */
     13,  13,  13,  13,  13,  13,  13,  13,  /*   1 */
     13,  13,  13,  13,  13,  13,  13,  13,  /*   1 */
     13,  13,  13,   5,   7,   6,   7,   0,  /*   1 */
      0,   0,   0,   0,   0,   0,   0,   0,  /*   2 */
      0,   0,   0,   0,   0,   0,   0,   0,  /*   2 */
      0,   0,   0,   0,   0,   0,   0,   0,  /*   2 */
      0,   0,   0,   0,   0,   0,   0,   0,  /*   2 */
     14,   3,   4,   4,   4,   4,  15,  15,  /*   2 */
     11,  15,  16,   5,   7,   8,  15,  11,  /*   2 */
     15,   7,  17,  17,  11,  16,  15,   3,  /*   2 */
     11,  18,  16,   6,  19,  19,  19,   3,  /*   2 */
     20,  20,  20,  20,  20,  20,  20,  20,  /*   3 */
     20,  20,  20,  20,  20,  20,  20,  20,  /*   3 */
     20,  20,  20,  20,  20,  20,  20,   7,  /*   3 */
     20,  20,  20,  20,  20,  20,  20,  16,  /*   3 */
     21,  21,  21,  21,  21,  21,  21,  21,  /*   3 */
     21,  21,  21,  21,  21,  21,  21,  21,  /*   3 */
     21,  21,  21,  21,  21,  21,  21,   7,  /*   3 */
     21,  21,  21,  21,  21,  21,  21,  22,  /*   3 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   4 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   4 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   4 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   4 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   4 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   4 */
     25,  26,  23,  24,  23,  24,  23,  24,  /*   4 */
     16,  23,  24,  23,  24,  23,  24,  23,  /*   4 */
     24,  23,  24,  23,  24,  23,  24,  23,  /*   5 */
     24,  16,  23,  24,  23,  24,  23,  24,  /*   5 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   5 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   5 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   5 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   5 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   5 */
     27,  23,  24,  23,  24,  23,  24,  28,  /*   5 */
     16,  29,  23,  24,  23,  24,  30,  23,  /*   6 */
     24,  31,  31,  23,  24,  16,  32,  32,  /*   6 */
     33,  23,  24,  31,  34,  16,  35,  36,  /*   6 */
     23,  24,  16,  16,  35,  37,  16,  38,  /*   6 */
     23,  24,  23,  24,  23,  24,  38,  23,  /*   6 */
     24,  39,  40,  16,  23,  24,  39,  23,  /*   6 */
     24,  41,  41,  23,  24,  23,  24,  42,  /*   6 */
     23,  24,  16,  40,  23,  24,  40,  40,  /*   6 */
     40,  40,  40,  40,  43,  44,  45,  43,  /*   7 */
     44,  45,  43,  44,  45,  23,  24,  23,  /*   7 */
     24,  23,  24,  23,  24,  23,  24,  23,  /*   7 */
     24,  23,  24,  23,  24,  16,  23,  24,  /*   7 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   7 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   7 */
     16,  43,  44,  45,  23,  24,  46,  46,  /*   7 */
     46,  46,  23,  24,  23,  24,  23,  24,  /*   7 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   8 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   8 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*   8 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*   8 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*   8 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*   8 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*   8 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*   8 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*   9 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*   9 */
     16,  16,  16,  47,  48,  16,  49,  49,  /*   9 */
     50,  50,  16,  51,  16,  16,  16,  16,  /*   9 */
     49,  16,  16,  52,  16,  16,  16,  16,  /*   9 */
     53,  54,  16,  16,  16,  16,  16,  54,  /*   9 */
     16,  16,  55,  16,  16,  16,  16,  16,  /*   9 */
     16,  16,  16,  16,  16,  16,  16,  16,  /*   9 */
     16,  16,  16,  56,  16,  16,  16,  16,  /*  10 */
     56,  16,  57,  57,  16,  16,  16,  16,  /*  10 */
     16,  16,  58,  16,  16,  16,  16,  16,  /*  10 */
     16,  16,  16,  16,  16,  16,  16,  16,  /*  10 */
     16,  16,  16,  16,  16,  16,  16,  16,  /*  10 */
     16,  46,  46,  46,  46,  46,  46,  46,  /*  10 */
     59,  59,  59,  59,  59,  59,  59,  59,  /*  10 */
     59,  11,  11,  59,  59,  59,  59,  59,  /*  10 */
     59,  59,  11,  11,  11,  11,  11,  11,  /*  11 */
     11,  11,  11,  11,  11,  11,  11,  11,  /*  11 */
     59,  59,  11,  11,  11,  11,  11,  11,  /*  11 */
     11,  11,  11,  11,  11,  11,  11,  46,  /*  11 */
     59,  59,  59,  59,  59,  11,  11,  11,  /*  11 */
     11,  11,  46,  46,  46,  46,  46,  46,  /*  11 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  11 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  11 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  12 */
     60,  60,  60,  60,  60,  60,  46,  46,  /*  13 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  13 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  13 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  13 */
     60,  60,  46,  46,  46,  46,  46,  46,  /*  13 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  13 */
     46,  46,  46,  46,   3,   3,  46,  46,  /*  13 */
     46,  46,  59,  46,  46,  46,   3,  46,  /*  13 */
     46,  46,  46,  46,  11,  11,  61,   3,  /*  14 */
     62,  62,  62,  46,  63,  46,  64,  64,  /*  14 */
     16,  20,  20,  20,  20,  20,  20,  20,  /*  14 */
     20,  20,  20,  20,  20,  20,  20,  20,  /*  14 */
     20,  20,  46,  20,  20,  20,  20,  20,  /*  14 */
     20,  20,  20,  20,  65,  66,  66,  66,  /*  14 */
     16,  21,  21,  21,  21,  21,  21,  21,  /*  14 */
     21,  21,  21,  21,  21,  21,  21,  21,  /*  14 */
     21,  21,  16,  21,  21,  21,  21,  21,  /*  15 */
     21,  21,  21,  21,  67,  68,  68,  46,  /*  15 */
     69,  70,  38,  38,  38,  71,  72,  46,  /*  15 */
     46,  46,  38,  46,  38,  46,  38,  46,  /*  15 */
     38,  46,  23,  24,  23,  24,  23,  24,  /*  15 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  15 */
     73,  74,  16,  40,  46,  46,  46,  46,  /*  15 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  15 */
     46,  75,  75,  75,  75,  75,  75,  75,  /*  16 */
     75,  75,  75,  75,  75,  46,  75,  75,  /*  16 */
     20,  20,  20,  20,  20,  20,  20,  20,  /*  16 */
     20,  20,  20,  20,  20,  20,  20,  20,  /*  16 */
     20,  20,  20,  20,  20,  20,  20,  20,  /*  16 */
     20,  20,  20,  20,  20,  20,  20,  20,  /*  16 */
     21,  21,  21,  21,  21,  21,  21,  21,  /*  16 */
     21,  21,  21,  21,  21,  21,  21,  21,  /*  16 */
     21,  21,  21,  21,  21,  21,  21,  21,  /*  17 */
     21,  21,  21,  21,  21,  21,  21,  21,  /*  17 */
     46,  74,  74,  74,  74,  74,  74,  74,  /*  17 */
     74,  74,  74,  74,  74,  46,  74,  74,  /*  17 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  17 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  17 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  17 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  17 */
     23,  24,  15,  60,  60,  60,  60,  46,  /*  18 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  18 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  18 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  18 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  18 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  18 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  18 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  18 */
     40,  23,  24,  23,  24,  46,  46,  23,  /*  19 */
     24,  46,  46,  23,  24,  46,  46,  46,  /*  19 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  19 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  19 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  19 */
     23,  24,  23,  24,  46,  46,  23,  24,  /*  19 */
     23,  24,  23,  24,  23,  24,  46,  46,  /*  19 */
     23,  24,  46,  46,  46,  46,  46,  46,  /*  19 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  20 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  20 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  20 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  20 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  20 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  20 */
     46,  76,  76,  76,  76,  76,  76,  76,  /*  20 */
     76,  76,  76,  76,  76,  76,  76,  76,  /*  20 */
     76,  76,  76,  76,  76,  76,  76,  76,  /*  21 */
     76,  76,  76,  76,  76,  76,  76,  76,  /*  21 */
     76,  76,  76,  76,  76,  76,  76,  46,  /*  21 */
     46,  59,   3,   3,   3,   3,   3,   3,  /*  21 */
     46,  77,  77,  77,  77,  77,  77,  77,  /*  21 */
     77,  77,  77,  77,  77,  77,  77,  77,  /*  21 */
     77,  77,  77,  77,  77,  77,  77,  77,  /*  21 */
     77,  77,  77,  77,  77,  77,  77,  77,  /*  21 */
     77,  77,  77,  77,  77,  77,  77,  16,  /*  22 */
     46,   3,  46,  46,  46,  46,  46,  46,  /*  22 */
     46,  60,  60,  60,  60,  60,  60,  60,  /*  22 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  22 */
     60,  60,  46,  60,  60,  60,  60,  60,  /*  22 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  22 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  22 */
     60,  60,  46,  60,  60,  60,   3,  60,  /*  22 */
      3,  60,  60,   3,  60,  46,  46,  46,  /*  23 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  23 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  23 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  23 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  23 */
     40,  40,  40,  46,  46,  46,  46,  46,  /*  23 */
     40,  40,  40,   3,   3,  46,  46,  46,  /*  23 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  23 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  24 */
     46,  46,  46,  46,   3,  46,  46,  46,  /*  24 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  24 */
     46,  46,  46,   3,  46,  46,  46,   3,  /*  24 */
     46,  40,  40,  40,  40,  40,  40,  40,  /*  24 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  24 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  24 */
     40,  40,  40,  46,  46,  46,  46,  46,  /*  24 */
     59,  40,  40,  40,  40,  40,  40,  40,  /*  25 */
     40,  40,  40,  60,  60,  60,  60,  60,  /*  25 */
     60,  60,  60,  46,  46,  46,  46,  46,  /*  25 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  25 */
     78,  78,  78,  78,  78,  78,  78,  78,  /*  25 */
     78,  78,   3,   3,   3,   3,  46,  46,  /*  25 */
     60,  40,  40,  40,  40,  40,  40,  40,  /*  25 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  25 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  26 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  26 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  26 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  26 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  26 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  26 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  26 */
     46,  46,  40,  40,  40,  40,  40,  46,  /*  26 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  27 */
     40,  40,  40,  40,  40,  40,  40,  46,  /*  27 */
     40,  40,  40,  40,   3,  40,  60,  60,  /*  27 */
     60,  60,  60,  60,  60,  79,  79,  60,  /*  27 */
     60,  60,  60,  60,  60,  59,  59,  60,  /*  27 */
     60,  15,  60,  60,  60,  60,  46,  46,  /*  27 */
      9,   9,   9,   9,   9,   9,   9,   9,  /*  27 */
      9,   9,  46,  46,  46,  46,  46,  46,  /*  27 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  28 */
     46,  60,  60,  80,  46,  40,  40,  40,  /*  29 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  29 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  29 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  29 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  29 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  29 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  29 */
     40,  40,  46,  46,  60,  40,  80,  80,  /*  29 */
     80,  60,  60,  60,  60,  60,  60,  60,  /*  30 */
     60,  80,  80,  80,  80,  60,  46,  46,  /*  30 */
     15,  60,  60,  60,  60,  46,  46,  46,  /*  30 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  30 */
     40,  40,  60,  60,   3,   3,  81,  81,  /*  30 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  30 */
      3,  46,  46,  46,  46,  46,  46,  46,  /*  30 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  30 */
     46,  60,  80,  80,  46,  40,  40,  40,  /*  31 */
     40,  40,  40,  40,  40,  46,  46,  40,  /*  31 */
     40,  46,  46,  40,  40,  40,  40,  40,  /*  31 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  31 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  31 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  31 */
     40,  46,  40,  46,  46,  46,  40,  40,  /*  31 */
     40,  40,  46,  46,  60,  46,  80,  80,  /*  31 */
     80,  60,  60,  60,  60,  46,  46,  80,  /*  32 */
     80,  46,  46,  80,  80,  60,  46,  46,  /*  32 */
     46,  46,  46,  46,  46,  46,  46,  80,  /*  32 */
     46,  46,  46,  46,  40,  40,  46,  40,  /*  32 */
     40,  40,  60,  60,  46,  46,  81,  81,  /*  32 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  32 */
     40,  40,   4,   4,  82,  82,  82,  82,  /*  32 */
     19,  83,  15,  46,  46,  46,  46,  46,  /*  32 */
     46,  46,  60,  46,  46,  40,  40,  40,  /*  33 */
     40,  40,  40,  46,  46,  46,  46,  40,  /*  33 */
     40,  46,  46,  40,  40,  40,  40,  40,  /*  33 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  33 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  33 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  33 */
     40,  46,  40,  40,  46,  40,  40,  46,  /*  33 */
     40,  40,  46,  46,  60,  46,  80,  80,  /*  33 */
     80,  60,  60,  46,  46,  46,  46,  60,  /*  34 */
     60,  46,  46,  60,  60,  60,  46,  46,  /*  34 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  34 */
     46,  40,  40,  40,  40,  46,  40,  46,  /*  34 */
     46,  46,  46,  46,  46,  46,  81,  81,  /*  34 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  34 */
     60,  60,  40,  40,  40,  46,  46,  46,  /*  34 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  34 */
     46,  60,  60,  80,  46,  40,  40,  40,  /*  35 */
     40,  40,  40,  40,  46,  40,  46,  40,  /*  35 */
     40,  40,  46,  40,  40,  40,  40,  40,  /*  35 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  35 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  35 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  35 */
     40,  46,  40,  40,  46,  40,  40,  40,  /*  35 */
     40,  40,  46,  46,  60,  40,  80,  80,  /*  35 */
     80,  60,  60,  60,  60,  60,  46,  60,  /*  36 */
     60,  80,  46,  80,  80,  60,  46,  46,  /*  36 */
     15,  46,  46,  46,  46,  46,  46,  46,  /*  36 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  36 */
     40,  46,  46,  46,  46,  46,  81,  81,  /*  36 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  36 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  36 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  36 */
     46,  60,  80,  80,  46,  40,  40,  40,  /*  37 */
     40,  40,  40,  40,  40,  46,  46,  40,  /*  37 */
     40,  46,  46,  40,  40,  40,  40,  40,  /*  37 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  37 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  37 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  37 */
     40,  46,  40,  40,  46,  46,  40,  40,  /*  37 */
     40,  40,  46,  46,  60,  40,  80,  60,  /*  37 */
     80,  60,  60,  60,  46,  46,  46,  80,  /*  38 */
     80,  46,  46,  80,  80,  60,  46,  46,  /*  38 */
     46,  46,  46,  46,  46,  46,  60,  80,  /*  38 */
     46,  46,  46,  46,  40,  40,  46,  40,  /*  38 */
     40,  40,  46,  46,  46,  46,  81,  81,  /*  38 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  38 */
     15,  46,  46,  46,  46,  46,  46,  46,  /*  38 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  38 */
     46,  46,  60,  80,  46,  40,  40,  40,  /*  39 */
     40,  40,  40,  46,  46,  46,  40,  40,  /*  39 */
     40,  46,  40,  40,  40,  40,  46,  46,  /*  39 */
     46,  40,  40,  46,  40,  46,  40,  40,  /*  39 */
     46,  46,  46,  40,  40,  46,  46,  46,  /*  39 */
     40,  40,  40,  46,  46,  46,  40,  40,  /*  39 */
     40,  40,  40,  40,  40,  40,  46,  40,  /*  39 */
     40,  40,  46,  46,  46,  46,  80,  80,  /*  39 */
     60,  80,  80,  46,  46,  46,  80,  80,  /*  40 */
     80,  46,  80,  80,  80,  60,  46,  46,  /*  40 */
     46,  46,  46,  46,  46,  46,  46,  80,  /*  40 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  40 */
     46,  46,  46,  46,  46,  46,  46,  81,  /*  40 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  40 */
     84,  19,  19,  46,  46,  46,  46,  46,  /*  40 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  40 */
     46,  80,  80,  80,  46,  40,  40,  40,  /*  41 */
     40,  40,  40,  40,  40,  46,  40,  40,  /*  41 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  41 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  41 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  41 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  41 */
     40,  40,  40,  40,  46,  40,  40,  40,  /*  41 */
     40,  40,  46,  46,  46,  46,  60,  60,  /*  41 */
     60,  80,  80,  80,  80,  46,  60,  60,  /*  42 */
     60,  46,  60,  60,  60,  60,  46,  46,  /*  42 */
     46,  46,  46,  46,  46,  60,  60,  46,  /*  42 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  42 */
     40,  40,  46,  46,  46,  46,  81,  81,  /*  42 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  42 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  42 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  42 */
     46,  46,  80,  80,  46,  40,  40,  40,  /*  43 */
     40,  40,  40,  40,  40,  46,  40,  40,  /*  43 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  43 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  43 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  43 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  43 */
     40,  40,  40,  40,  46,  40,  40,  40,  /*  43 */
     40,  40,  46,  46,  46,  46,  80,  60,  /*  43 */
     80,  80,  80,  80,  80,  46,  60,  80,  /*  44 */
     80,  46,  80,  80,  60,  60,  46,  46,  /*  44 */
     46,  46,  46,  46,  46,  80,  80,  46,  /*  44 */
     46,  46,  46,  46,  46,  46,  40,  46,  /*  44 */
     40,  40,  46,  46,  46,  46,  81,  81,  /*  44 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  44 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  44 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  44 */
     46,  46,  80,  80,  46,  40,  40,  40,  /*  45 */
     40,  40,  40,  40,  40,  46,  40,  40,  /*  45 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  45 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  45 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  45 */
     40,  46,  40,  40,  40,  40,  40,  40,  /*  45 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  45 */
     40,  40,  46,  46,  46,  46,  80,  80,  /*  45 */
     80,  60,  60,  60,  46,  46,  80,  80,  /*  46 */
     80,  46,  80,  80,  80,  60,  46,  46,  /*  46 */
     46,  46,  46,  46,  46,  46,  46,  80,  /*  46 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  46 */
     40,  40,  46,  46,  46,  46,  81,  81,  /*  46 */
     81,  81,  81,  81,  81,  81,  81,  81,  /*  46 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  46 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  46 */
     46,  40,  40,  40,  40,  40,  40,  40,  /*  47 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  47 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  47 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  47 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  47 */
     40,  40,  40,  40,  40,  40,  40,   3,  /*  47 */
     40,  60,  40,  40,  60,  60,  60,  60,  /*  47 */
     60,  60,  60,  46,  46,  46,  46,   4,  /*  47 */
     40,  40,  40,  40,  40,  40,  59,  60,  /*  48 */
     60,  60,  60,  60,  60,  60,  60,  15,  /*  48 */
      9,   9,   9,   9,   9,   9,   9,   9,  /*  48 */
      9,   9,   3,   3,  46,  46,  46,  46,  /*  48 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  48 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  48 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  48 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  48 */
     46,  40,  40,  46,  40,  46,  46,  40,  /*  49 */
     40,  46,  40,  46,  46,  40,  46,  46,  /*  49 */
     46,  46,  46,  46,  40,  40,  40,  40,  /*  49 */
     46,  40,  40,  40,  40,  40,  40,  40,  /*  49 */
     46,  40,  40,  40,  46,  40,  46,  40,  /*  49 */
     46,  46,  40,  40,  46,  40,  40,   3,  /*  49 */
     40,  60,  40,  40,  60,  60,  60,  60,  /*  49 */
     60,  60,  46,  60,  60,  40,  46,  46,  /*  49 */
     40,  40,  40,  40,  40,  46,  59,  46,  /*  50 */
     60,  60,  60,  60,  60,  60,  46,  46,  /*  50 */
      9,   9,   9,   9,   9,   9,   9,   9,  /*  50 */
      9,   9,  46,  46,  40,  40,  46,  46,  /*  50 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  50 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  50 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  50 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  50 */
     15,  15,  15,  15,   3,   3,   3,   3,  /*  51 */
      3,   3,   3,   3,   3,   3,   3,   3,  /*  51 */
      3,   3,   3,  15,  15,  15,  15,  15,  /*  51 */
     60,  60,  15,  15,  15,  15,  15,  15,  /*  51 */
     78,  78,  78,  78,  78,  78,  78,  78,  /*  51 */
     78,  78,  85,  85,  85,  85,  85,  85,  /*  51 */
     85,  85,  85,  85,  15,  60,  15,  60,  /*  51 */
     15,  60,   5,   6,   5,   6,  80,  80,  /*  51 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  52 */
     46,  40,  40,  40,  40,  40,  40,  40,  /*  52 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  52 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  52 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  52 */
     40,  40,  46,  46,  46,  46,  46,  46,  /*  52 */
     46,  60,  60,  60,  60,  60,  60,  60,  /*  52 */
     60,  60,  60,  60,  60,  60,  60,  80,  /*  52 */
     60,  60,  60,  60,  60,   3,  60,  60,  /*  53 */
     60,  60,  60,  60,  46,  46,  46,  46,  /*  53 */
     60,  60,  60,  60,  60,  60,  46,  60,  /*  53 */
     46,  60,  60,  60,  60,  60,  60,  60,  /*  53 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  53 */
     60,  60,  60,  60,  60,  60,  46,  46,  /*  53 */
     46,  60,  60,  60,  60,  60,  60,  60,  /*  53 */
     46,  60,  46,  46,  46,  46,  46,  46,  /*  53 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  54 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  54 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  54 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  54 */
     76,  76,  76,  76,  76,  76,  76,  76,  /*  54 */
     76,  76,  76,  76,  76,  76,  76,  76,  /*  54 */
     76,  76,  76,  76,  76,  76,  76,  76,  /*  54 */
     76,  76,  76,  76,  76,  76,  76,  76,  /*  54 */
     76,  76,  76,  76,  76,  76,  46,  46,  /*  55 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  55 */
     16,  16,  16,  16,  16,  16,  16,  16,  /*  55 */
     16,  16,  16,  16,  16,  16,  16,  16,  /*  55 */
     16,  16,  16,  16,  16,  16,  16,  16,  /*  55 */
     16,  16,  16,  16,  16,  16,  16,  16,  /*  55 */
     16,  16,  16,  16,  16,  16,  16,  46,  /*  55 */
     46,  46,  46,   3,  46,  46,  46,  46,  /*  55 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  56 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  57 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  57 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  57 */
     40,  40,  46,  46,  46,  46,  46,  40,  /*  57 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  57 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  57 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  57 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  57 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  58 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  58 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  58 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  58 */
     40,  40,  40,  46,  46,  46,  46,  46,  /*  58 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  58 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  58 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  58 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  59 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  59 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  59 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  59 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  59 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  59 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  59 */
     40,  40,  46,  46,  46,  46,  46,  46,  /*  59 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  60 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  61 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  61 */
     23,  24,  23,  24,  23,  24,  16,  16,  /*  61 */
     16,  16,  16,  16,  46,  46,  46,  46,  /*  61 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  61 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  61 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  61 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  61 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  62 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  62 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  62 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  62 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  62 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  62 */
     23,  24,  23,  24,  23,  24,  23,  24,  /*  62 */
     23,  24,  46,  46,  46,  46,  46,  46,  /*  62 */
     86,  86,  86,  86,  86,  86,  86,  86,  /*  63 */
     87,  87,  87,  87,  87,  87,  87,  87,  /*  63 */
     86,  86,  86,  86,  86,  86,  46,  46,  /*  63 */
     87,  87,  87,  87,  87,  87,  46,  46,  /*  63 */
     86,  86,  86,  86,  86,  86,  86,  86,  /*  63 */
     87,  87,  87,  87,  87,  87,  87,  87,  /*  63 */
     86,  86,  86,  86,  86,  86,  86,  86,  /*  63 */
     87,  87,  87,  87,  87,  87,  87,  87,  /*  63 */
     86,  86,  86,  86,  86,  86,  46,  46,  /*  64 */
     87,  87,  87,  87,  87,  87,  46,  46,  /*  64 */
     16,  86,  16,  86,  16,  86,  16,  86,  /*  64 */
     46,  87,  46,  87,  46,  87,  46,  87,  /*  64 */
     86,  86,  86,  86,  86,  86,  86,  86,  /*  64 */
     87,  87,  87,  87,  87,  87,  87,  87,  /*  64 */
     88,  88,  89,  89,  89,  89,  90,  90,  /*  64 */
     91,  91,  92,  92,  93,  93,  46,  46,  /*  64 */
     86,  86,  86,  86,  86,  86,  86,  86,  /*  65 */
     87,  87,  87,  87,  87,  87,  87,  87,  /*  65 */
     86,  86,  86,  86,  86,  86,  86,  86,  /*  65 */
     87,  87,  87,  87,  87,  87,  87,  87,  /*  65 */
     86,  86,  86,  86,  86,  86,  86,  86,  /*  65 */
     87,  87,  87,  87,  87,  87,  87,  87,  /*  65 */
     86,  86,  16,  94,  16,  46,  16,  16,  /*  65 */
     87,  87,  95,  95,  96,  11,  38,  11,  /*  65 */
     11,  11,  16,  94,  16,  46,  16,  16,  /*  66 */
     97,  97,  97,  97,  96,  11,  11,  11,  /*  66 */
     86,  86,  16,  16,  46,  46,  16,  16,  /*  66 */
     87,  87,  98,  98,  46,  11,  11,  11,  /*  66 */
     86,  86,  16,  16,  16,  99,  16,  16,  /*  66 */
     87,  87, 100, 100, 101,  11,  11,  11,  /*  66 */
     46,  46,  16,  94,  16,  46,  16,  16,  /*  66 */
    102, 102, 103, 103,  96,  11,  11,  46,  /*  66 */
      2,   2,   2,   2,   2,   2,   2,   2,  /*  67 */
      2,   2,   2,   2, 104, 104, 104, 104,  /*  67 */
      8,   8,   8,   8,   8,   8,   3,   3,  /*  67 */
      5,   6,   5,   5,   5,   6,   5,   5,  /*  67 */
      3,   3,   3,   3,   3,   3,   3,   3,  /*  67 */
    105, 106, 104, 104, 104, 104, 104,  46,  /*  67 */
      3,   3,   3,   3,   3,   3,   3,   3,  /*  67 */
      3,   5,   6,   3,   3,   3,   3,  12,  /*  67 */
     12,   3,   3,   3,   7,   5,   6,  46,  /*  68 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  68 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  68 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  68 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  68 */
     46,  46, 104, 104, 104, 104, 104, 104,  /*  68 */
     17,  46,  46,  46,  17,  17,  17,  17,  /*  68 */
     17,  17,   7,   7,   7,   5,   6,  16,  /*  68 */
    107, 107, 107, 107, 107, 107, 107, 107,  /*  69 */
    107, 107,   7,   7,   7,   5,   6,  46,  /*  69 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  69 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  69 */
      4,   4,   4,   4,   4,   4,   4,   4,  /*  69 */
      4,   4,   4,   4,  46,  46,  46,  46,  /*  69 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  69 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  69 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  70 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  70 */
     60,  60,  60,  60,  60,  60,  60,  60,  /*  70 */
     60,  60,  60,  60,  60,  79,  79,  79,  /*  70 */
     79,  60,  46,  46,  46,  46,  46,  46,  /*  70 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  70 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  70 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  70 */
     15,  15,  38,  15,  15,  15,  15,  38,  /*  71 */
     15,  15,  16,  38,  38,  38,  16,  16,  /*  71 */
     38,  38,  38,  16,  15,  38,  15,  15,  /*  71 */
     38,  38,  38,  38,  38,  38,  15,  15,  /*  71 */
     15,  15,  15,  15,  38,  15,  38,  15,  /*  71 */
     38,  15,  38,  38,  38,  38,  16,  16,  /*  71 */
     38,  38,  15,  38,  16,  40,  40,  40,  /*  71 */
     40,  46,  46,  46,  46,  46,  46,  46,  /*  71 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  72 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  72 */
     46,  46,  46,  19,  19,  19,  19,  19,  /*  72 */
     19,  19,  19,  19,  19,  19,  19, 108,  /*  72 */
    109, 109, 109, 109, 109, 109, 109, 109,  /*  72 */
    109, 109, 109, 109, 110, 110, 110, 110,  /*  72 */
    111, 111, 111, 111, 111, 111, 111, 111,  /*  72 */
    111, 111, 111, 111, 112, 112, 112, 112,  /*  72 */
    113, 113, 113,  46,  46,  46,  46,  46,  /*  73 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  73 */
      7,   7,   7,   7,   7,  15,  15,  15,  /*  73 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  73 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  73 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  73 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  73 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  73 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  74 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  74 */
     15,  15,   7,  15,   7,  15,  15,  15,  /*  74 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  74 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  74 */
     15,  15,  15,  46,  46,  46,  46,  46,  /*  74 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  74 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  74 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  75 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  76 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  76 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  76 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  76 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  76 */
      7,   7,   7,   7,   7,   7,   7,   7,  /*  76 */
      7,   7,  46,  46,  46,  46,  46,  46,  /*  76 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  76 */
     15,  46,  15,  15,  15,  15,  15,  15,  /*  77 */
      7,   7,   7,   7,  15,  15,  15,  15,  /*  77 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  77 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  77 */
      7,   7,  15,  15,  15,  15,  15,  15,  /*  77 */
     15,   5,   6,  15,  15,  15,  15,  15,  /*  77 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  77 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  77 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  78 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  78 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  78 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  78 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  78 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  78 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  78 */
     15,  15,  15,  46,  46,  46,  46,  46,  /*  78 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  79 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  79 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  79 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  79 */
     15,  15,  15,  15,  15,  46,  46,  46,  /*  79 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  79 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  79 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  79 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  80 */
     15,  15,  15,  46,  46,  46,  46,  46,  /*  80 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  80 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  80 */
    114, 114, 114, 114, 114, 114, 114, 114,  /*  80 */
    114, 114, 114, 114, 114, 114, 114, 114,  /*  80 */
    114, 114, 114, 114,  82,  82,  82,  82,  /*  80 */
     82,  82,  82,  82,  82,  82,  82,  82,  /*  80 */
     82,  82,  82,  82,  82,  82,  82,  82,  /*  81 */
    115, 115, 115, 115, 115, 115, 115, 115,  /*  81 */
    115, 115, 115, 115, 115, 115, 115, 115,  /*  81 */
    115, 115, 115, 115,  15,  15,  15,  15,  /*  81 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  81 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  81 */
     15,  15,  15,  15,  15,  15, 116, 116,  /*  81 */
    116, 116, 116, 116, 116, 116, 116, 116,  /*  81 */
    116, 116, 116, 116, 116, 116, 116, 116,  /*  82 */
    116, 116, 116, 116, 116, 116, 116, 116,  /*  82 */
    117, 117, 117, 117, 117, 117, 117, 117,  /*  82 */
    117, 117, 117, 117, 117, 117, 117, 117,  /*  82 */
    117, 117, 117, 117, 117, 117, 117, 117,  /*  82 */
    117, 117, 118,  46,  46,  46,  46,  46,  /*  82 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  82 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  82 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  83 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  84 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  84 */
     15,  15,  15,  15,  15,  15,  46,  46,  /*  84 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  84 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  84 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  84 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  84 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  84 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  85 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  85 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  85 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  85 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  85 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  85 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  85 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  85 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  86 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  86 */
     15,  15,  15,  15,  46,  46,  46,  46,  /*  86 */
     46,  46,  15,  15,  15,  15,  15,  15,  /*  86 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  86 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  86 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  86 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  86 */
     46,  15,  15,  15,  15,  46,  15,  15,  /*  87 */
     15,  15,  46,  46,  15,  15,  15,  15,  /*  87 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  87 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  87 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  87 */
     46,  15,  15,  15,  15,  15,  15,  15,  /*  87 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  87 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  87 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  88 */
     15,  15,  15,  15,  46,  15,  46,  15,  /*  88 */
     15,  15,  15,  46,  46,  46,  15,  46,  /*  88 */
     15,  15,  15,  15,  15,  15,  15,  46,  /*  88 */
     46,  15,  15,  15,  15,  15,  15,  15,  /*  88 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  88 */
     46,  46,  46,  46,  46,  46, 119, 119,  /*  88 */
    119, 119, 119, 119, 119, 119, 119, 119,  /*  88 */
    114, 114, 114, 114, 114, 114, 114, 114,  /*  89 */
    114, 114,  83,  83,  83,  83,  83,  83,  /*  89 */
     83,  83,  83,  83,  15,  46,  46,  46,  /*  89 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  89 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  89 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  89 */
     46,  15,  15,  15,  15,  15,  15,  15,  /*  89 */
     15,  15,  15,  15,  15,  15,  15,  46,  /*  89 */
      2,   3,   3,   3,  15,  59,   3, 120,  /*  90 */
      5,   6,   5,   6,   5,   6,   5,   6,  /*  90 */
      5,   6,  15,  15,   5,   6,   5,   6,  /*  90 */
      5,   6,   5,   6,   8,   5,   6,   5,  /*  90 */
     15, 121, 121, 121, 121, 121, 121, 121,  /*  90 */
    121, 121,  60,  60,  60,  60,  60,  60,  /*  90 */
      8,  59,  59,  59,  59,  59,  15,  15,  /*  90 */
     46,  46,  46,  46,  46,  46,  46,  15,  /*  90 */
     46,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  91 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  92 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  92 */
     40,  40,  40,  40,  40,  46,  46,  46,  /*  92 */
     46,  60,  60,  59,  59,  59,  59,  46,  /*  92 */
     46,  40,  40,  40,  40,  40,  40,  40,  /*  92 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  92 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  92 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  92 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  93 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  93 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  93 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  93 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  93 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  93 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  93 */
     40,  40,  40,   3,  59,  59,  59,  46,  /*  93 */
     46,  46,  46,  46,  46,  40,  40,  40,  /*  94 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  94 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  94 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  94 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  94 */
     40,  40,  40,  40,  40,  46,  46,  46,  /*  94 */
     46,  40,  40,  40,  40,  40,  40,  40,  /*  94 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  94 */
     40,  40,  40,  40,  40,  40,  40,  40,  /*  95 */
     40,  40,  40,  40,  40,  40,  40,  46,  /*  95 */
     15,  15,  85,  85,  85,  85,  15,  15,  /*  95 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  95 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  95 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  95 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  95 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  95 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  96 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  96 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  96 */
     15,  15,  15,  15,  15,  46,  46,  46,  /*  96 */
     85,  85,  85,  85,  85,  85,  85,  85,  /*  96 */
     85,  85,  15,  15,  15,  15,  15,  15,  /*  96 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  96 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  96 */
     15,  15,  15,  15,  46,  46,  46,  46,  /*  97 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  97 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  97 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  97 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  97 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  97 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  97 */
     15,  15,  15,  15,  46,  46,  46,  15,  /*  97 */
    114, 114, 114, 114, 114, 114, 114, 114,  /*  98 */
    114, 114,  15,  15,  15,  15,  15,  15,  /*  98 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  98 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  98 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  98 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  98 */
     15,  46,  46,  46,  46,  46,  46,  46,  /*  98 */
     46,  46,  46,  46,  46,  46,  46,  46,  /*  98 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  99 */
     15,  15,  15,  15,  46,  46,  46,  46,  /*  99 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  99 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  99 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  99 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  99 */
     15,  15,  15,  15,  15,  15,  15,  15,  /*  99 */
     15,  15,  15,  15,  15,  15,  15,  46,  /*  99 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 100 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 100 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 100 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 100 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 100 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 100 */
     15,  15,  15,  15,  15,  15,  15,  46,  /* 100 */
     46,  46,  46,  15,  15,  15,  15,  15,  /* 100 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 101 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 101 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 101 */
     15,  15,  15,  15,  15,  15,  46,  46,  /* 101 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 101 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 101 */
     15,  15,  15,  15,  15,  15,  15,  15,  /* 101 */
     15,  15,  15,  15,  15,  15,  15,  46,  /* 101 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 102 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 102 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 102 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 102 */
     40,  40,  40,  40,  40,  40,  46,  46,  /* 102 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 102 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 102 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 102 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 103 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 103 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 103 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 103 */
     40,  40,  40,  40,  46,  46,  46,  46,  /* 103 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 103 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 103 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 103 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    122, 122, 122, 122, 122, 122, 122, 122,  /* 104 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
    123, 123, 123, 123, 123, 123, 123, 123,  /* 105 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 106 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 106 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 106 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 106 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 106 */
     40,  40,  40,  40,  40,  40,  46,  46,  /* 106 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 106 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 106 */
     16,  16,  16,  16,  16,  16,  16,  46,  /* 107 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 107 */
     46,  46,  46,  16,  16,  16,  16,  16,  /* 107 */
     46,  46,  46,  46,  46,  46,  60,  40,  /* 107 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 107 */
     40,   7,  40,  40,  40,  40,  40,  40,  /* 107 */
     40,  40,  40,  40,  40,  40,  40,  46,  /* 107 */
     40,  40,  40,  40,  40,  46,  40,  46,  /* 107 */
     40,  40,  46,  40,  40,  46,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 108 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 109 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 109 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 109 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 109 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 109 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 109 */
     40,  40,  46,  46,  46,  46,  46,  46,  /* 109 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 109 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 110 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 110 */
     46,  46,  46,  40,  40,  40,  40,  40,  /* 110 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 110 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 110 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 110 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 110 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 110 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 111 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 111 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 111 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 111 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 111 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 111 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 111 */
     40,  40,  40,  40,  40,  40,   5,   6,  /* 111 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 112 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 112 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 112 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 112 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 112 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 112 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 112 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 112 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 113 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 113 */
     46,  46,  40,  40,  40,  40,  40,  40,  /* 113 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 113 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 113 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 113 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 113 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 113 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 114 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 114 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 114 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 114 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 114 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 114 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 114 */
     40,  40,  40,  40,  46,  46,  46,  46,  /* 114 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 115 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 115 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 115 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 115 */
     60,  60,  60,  60,  46,  46,  46,  46,  /* 115 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 115 */
      3,   8,   8,  12,  12,   5,   6,   5,  /* 115 */
      6,   5,   6,   5,   6,   5,   6,   5,  /* 115 */
      6,   5,   6,   5,   6,  46,  46,  46,  /* 116 */
     46,   3,   3,   3,   3,  12,  12,  12,  /* 116 */
      3,   3,   3,  46,   3,   3,   3,   3,  /* 116 */
      8,   5,   6,   5,   6,   5,   6,   3,  /* 116 */
      3,   3,   7,   8,   7,   7,   7,  46,  /* 116 */
      3,   4,   3,   3,  46,  46,  46,  46,  /* 116 */
     40,  40,  40,  46,  40,  46,  40,  40,  /* 116 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 116 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 117 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 117 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 117 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 117 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 117 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 117 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 117 */
     40,  40,  40,  40,  40,  46,  46, 104,  /* 117 */
     46,   3,   3,   3,   4,   3,   3,   3,  /* 118 */
      5,   6,   3,   7,   3,   8,   3,   3,  /* 118 */
      9,   9,   9,   9,   9,   9,   9,   9,  /* 118 */
      9,   9,   3,   3,   7,   7,   7,   3,  /* 118 */
      3,  10,  10,  10,  10,  10,  10,  10,  /* 118 */
     10,  10,  10,  10,  10,  10,  10,  10,  /* 118 */
     10,  10,  10,  10,  10,  10,  10,  10,  /* 118 */
     10,  10,  10,   5,   3,   6,  11,  12,  /* 118 */
     11,  13,  13,  13,  13,  13,  13,  13,  /* 119 */
     13,  13,  13,  13,  13,  13,  13,  13,  /* 119 */
     13,  13,  13,  13,  13,  13,  13,  13,  /* 119 */
     13,  13,  13,   5,   7,   6,   7,  46,  /* 119 */
     46,   3,   5,   6,   3,   3,  40,  40,  /* 119 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 119 */
     59,  40,  40,  40,  40,  40,  40,  40,  /* 119 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 119 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 120 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 120 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 120 */
     40,  40,  40,  40,  40,  40,  59,  59,  /* 120 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 120 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 120 */
     40,  40,  40,  40,  40,  40,  40,  40,  /* 120 */
     40,  40,  40,  40,  40,  40,  40,  46,  /* 120 */
     46,  46,  40,  40,  40,  40,  40,  40,  /* 121 */
     46,  46,  40,  40,  40,  40,  40,  40,  /* 121 */
     46,  46,  40,  40,  40,  40,  40,  40,  /* 121 */
     46,  46,  40,  40,  40,  46,  46,  46,  /* 121 */
      4,   4,   7,  11,  15,   4,   4,  46,  /* 121 */
      7,   7,   7,   7,   7,  15,  15,  46,  /* 121 */
     46,  46,  46,  46,  46,  46,  46,  46,  /* 121 */
     46,  46,  46,  46,  46,  15,  46,  46   /* 121 */
};

HArrayOfByte *
java_lang_Character_getY(struct Hjava_lang_Character *this)
{
    HArrayOfByte *yHandle = &Yhandle;

    unhand(yHandle) = (ClassArrayOfByte *)Y;
    obj_methodtable(yHandle) = (struct methodtable *) mkatype(T_BYTE, 7808);
    return yHandle;
}

















































