/*
 * @(#)java_lang_ClassLoader_getSystemResourceAsName0.c	1.3 98/10/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *	Native methods needed to locate resource files in the system class loader
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "oobj.h"
#include "path.h"
#include "interpreter.h"
#include "monitor.h"
#include "sys_api.h"

#include "java_lang_ClassLoader.h"

Hjava_lang_String *
java_lang_ClassLoader_getSystemResourceAsName0(Hjava_lang_ClassLoader *this, HString *name)
{
    char rname[MAXPATHLEN];
    Hjava_lang_String *back;

    javaString2CString(name, rname, sizeof(rname));

    if ((back = (Hjava_lang_String *) GetURLName(rname)) == 0) {
	return 0;
    }
    return back;
}
