/*
 * @(#)java_lang_SecurityManager_getClassContext.c	1.1 98/10/14
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "native.h"
#include "java_lang_SecurityManager.h"
#include "javaString.h"

extern bool_t
checkSecurityManagerInitialized(JNIEnv *env, jobject this);

extern HArrayOfObject *
getClassContext();

JNIEXPORT jobjectArray JNICALL
Java_java_lang_SecurityManager_getClassContext(JNIEnv *env, jobject this)
{
    if (!checkSecurityManagerInitialized(env, this))
	return NULL;		/* exception */
    return MkRefLocal(env, getClassContext());
}

