/*
 * @(#)java_lang_reflect_Field_getByte.c	1.1 98/08/27
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native code for java.lang.reflect.Field.
 *
 * TODO: Performance
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#include "sys_api.h"				/* sysAssert() */
#include "wrap.h"

#include "java_lang_reflect_Field.h"

extern JavaValue 
get_primitive_field( struct Hjava_lang_reflect_Field * hf,
                     struct Hjava_lang_Object * o, 
                     unsigned char wCode); 

char
java_lang_reflect_Field_getByte(
    struct Hjava_lang_reflect_Field * hf,
    struct Hjava_lang_Object * o)
{
    return (char) get_primitive_field(hf, o, T_BYTE).i;
}
