/*
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include <oobj.h>
#include <interpreter.h>

#ident "@(#)null_preloader.c	1.12 98/09/20 SMI"

/* support for the preloader
 *
 * Moved from fakes.c, as it doesn't really belong there.
 * a 24 Apr 96
 */

void
UseROMClasses()
{
}
 
char ROMClassesInfo[1];
JHandle *StaticRefStorage[1];

const int numRomClasses = 0;
const int StaticRefStorageCount = 0;

struct StrIDhash *nameTypeHash;
struct StrIDhash *stringHash;

ClassClass *classJavaLangObject;
ClassClass *classJavaLangThread;
ClassClass *classJavaLangClass;
ClassClass *classJavaLangString;
ClassClass *classJavaLangThrowable;
ClassClass *classJavaLangError;
ClassClass *classJavaLangException;
ClassClass *classJavaLangRuntimeException;
ClassClass *classJavaLangThreadDeath;

ClassClass *interfaceJavaLangCloneable;
ClassClass *interfaceJavaIoSerializable;

ClassClass *classSunMiscRef;

ClassClass *class_void;
ClassClass *class_boolean;
ClassClass *class_byte;
ClassClass *class_char;
ClassClass *class_short;
ClassClass *class_int;
ClassClass *class_long;
ClassClass *class_float;
ClassClass *class_double;

isROMPureCode(char *pc) { return 0; }
