/*
 *	DumpMultiClass.java	1.5	97/06/30 SMI
 *
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

import components.*;
import java.io.PrintStream;

/*
 * A simple little program to look at multi-class files
 * by reading in and calling dump().
 * Parameters: list of files to process.
 */

public class DumpMultiClass{

    public static void main( String mlist[] ){

	for( int i = 0; i < mlist.length; i++ ){
	    MultiClass f = new MultiClass( mlist[i], null, true );
	    System.out.println("Reading "+mlist[i] );
	    if (f.readMultiClassFile() != true ){
		System.out.println("Read of "+mlist[i]+" Failed");
	    } else {
		for (int j=0; j < f.classes.length; j++ ){
		    f.classes[j].findReferences();
		    f.classes[j].countReferences( true );
		}
	    }
	    f.dump( System.out );
	}
    }
}
