/*
 * @(#)aw.c	1.2 98/05/13 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
#include "jni.h"

JNIEXPORT void JNICALL
Java_sun_awt_aw_Window_lock0(JNIEnv *env,
			     jobject obj,
			     jobject lock)
{
    (*env)->MonitorEnter(env, lock);
}

JNIEXPORT void JNICALL
Java_sun_awt_aw_Window_unlock0(JNIEnv *env,
			       jobject obj,
			       jobject lock)
{
    (*env)->MonitorExit(env, lock);
}
