/*
 * @(#)AudioData.java	1.18 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

/**
 * A clip of audio data, contains ulaw 8bit, 8000hz data.
 * This data can be used to construct and AudioDataStream,
 * which can be played. <p>
 *
 * @author  Arthur van Hoff
 * @version 1.18, 07/01/98
 * @see     AudioDataStream
 * @see     AudioPlayer
 */
public
class AudioData {
    /**
     * The data
     */
    byte buffer[];

    /**
     * Constructor
     */
    public AudioData(byte buffer[]) {
	this.buffer = buffer;
    }
}
