/*
 * @(#)sun_net_www_protocol_systemresource_SystemResourceManager_getEntryFromKey.c	1.2 98/10/13
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 *	Routines to support the systemresource protocol
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "oobj.h"
#include "path.h"
#include "interpreter.h"

#include "sys_api.h"

#include "sun_net_www_protocol_systemresource_SystemResourceManager.h"

extern HString *
resource_GetEntryFromKey(long key);

/*-
 * Convert a KEY value into the actual CLASSPATH entry it represents
 * By using opaque KEYS we are hiding information on files on the users machine
 */

HString *
sun_net_www_protocol_systemresource_SystemResourceManager_getEntryFromKey(Hsun_net_www_protocol_systemresource_SystemResourceManager *this,
    long key) {
  return resource_GetEntryFromKey(key);
}
