/*
 * @(#)interpreter_md.h	1.1 98/04/14
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#ifndef _WIN32_INTERPRETER_MD_H_
#define _WIN32_INTERPRETER_MD_H_

/*
 * Stack red-zones used by sysThreadCheckStack().
 * Current implementation of sysThreadCheckStack() of Win32 does not 
 * check the size actually. Thus, these red-zones have no effect.
 */
#define STACK_REDZONE (0 * 1024) /* no effect */
/*
 * STACK_REDZONE_NATIVE is used by the stack check just before calling
 * native method implementation.
 */
#define STACK_REDZONE_NATIVE (0 * 1024) /* no effect */

#endif /*_WIN32_INTERPRETER_MD_H_*/
