/*
 * @(#)java_lang_Win32Process_exitValue.c	1.2 98/10/13
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <stdio.h>
#include <errno.h>
#include <ctype.h>

#include "sys_api.h"

#ifndef _WIN32_WCE /* pJava/WinCE does not support java.lang.Win32Process */

#include "java_lang_Win32Process.h"

long
java_lang_Win32Process_exitValue(Hjava_lang_Win32Process *Hthis)
{
    long exit_code;

    GetExitCodeProcess((HANDLE)unhand(Hthis)->handle, &exit_code);
    if (exit_code == STILL_ACTIVE) {
	SignalError(0, "java/lang/IllegalThreadStateException", "process has not exited");
	return -1;
    }
    return exit_code;
}

#endif /* !_WIN32_WCE */
