/*
 * @(#)AudioTranslatorStream.java	1.4 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.audio;

import java.io.InputStream;
import java.io.DataInputStream;
import java.io.FilterInputStream;
import java.io.IOException;

/**
 * A Sun-specific AudioStream that supports the .au file format. 
 *
 * @version 	1.1, 22 Aug 1995
 */
public
class AudioTranslatorStream extends NativeAudioStream {

    private int length = 0;

    public AudioTranslatorStream(InputStream in) throws IOException {
	super(in);
	// No translators supported yet.
	throw new InvalidAudioFormatException();
    }

    public int getLength() {
	return length;
    }
}
