/*
 * @(#)WObjectPeer.java	1.5 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.Component;

abstract class WObjectPeer {
    int       pData;	// The Windows handle for the native widget.
    Object    target;	// The associated AWT object.

    abstract public void dispose();

    public WObjectPeer getPeerForTarget(Object t) {
	WObjectPeer peer = (WObjectPeer) WToolkit.targetToPeer(t);
	return peer;
    }
}
