/*
 * @(#)awt_TextArea.h	1.5 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_TEXTAREA_H
#define AWT_TEXTAREA_H

#include "awt_TextComponent.h"

#include "java_awt_TextArea.h"
#include "sun_awt_windows_WTextAreaPeer.h"

//
// Component base class for system provided text edit controls
//
class AwtTextArea : public AwtTextComponent {
public:
    AwtTextArea();

    static AwtTextArea* Create(Hsun_awt_windows_WTextAreaPeer* self,
                               Hsun_awt_windows_WComponentPeer* hParent);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WTextAreaPeer* GetPeer() { 
	return (Hsun_awt_windows_WTextAreaPeer*)m_peerObject; 
    }

    static int CountNewLines(Hjava_lang_String* jStr, int maxlen);
};

#endif // AWT_TEXTAREA_H
