/*
 * @(#)awt_TextField.h	1.9 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_TEXTFIELD_H
#define AWT_TEXTFIELD_H

#include "awt_TextComponent.h"

#include "java_awt_TextField.h"
#include "sun_awt_windows_WTextFieldPeer.h"

//
// Component base class for system provided text edit controls
//
class AwtTextField : public AwtTextComponent {
public:
    AwtTextField();

    static AwtTextField* Create(Hsun_awt_windows_WTextFieldPeer* self,
                                Hsun_awt_windows_WComponentPeer* hParent);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WTextFieldPeer* GetPeer() { 
	return (Hsun_awt_windows_WTextFieldPeer*)m_peerObject; 
    }

    //////// Windows message handler functions

    MsgRouting WmChar(UINT character, UINT repCnt, UINT flags, BOOL system);

};

#endif // AWT_TEXTFIELD_H
