/*
	File : ManInfo.java
	Date		Author		Change
	2001/10/12	Kim.K.C.	Created
*/

package com.xce.xceman.client;

import javax.microedition.lcdui.*;
import com.xce.xceman.common.*;

class ManInfo implements Protocol {	
	static ManInfo[] infos = new ManInfo[MAX_MAN];
	
	int x;
	int y;
	
	static void move(int id, int x, int y) {
		if (infos[id] == null) {
			infos[id] = new ManInfo();
		}
		
		infos[id].x = x;
		infos[id].y = y;
	}
	
	private ManInfo() {
	}
	
	static void remove(int id) {
		infos[id] = null;
	}
	
	static void removeAll() {
		for (int i = 0; i < infos.length; i++) {
			infos[i] = null;
		}
	}
	
	static void paint(Graphics g, Image img) {
		for (int i = 0; i < infos.length; i++) {
			if (infos[i] != null) {
				g.drawImage(img, infos[i].x, infos[i].y, Graphics.TOP | Graphics.LEFT);
			}
		}
	}
}