import javax.microedition.lcdui.*;

import com.xce.xlcdui.*;

/**
  * Ʈ  ֱ  
  * 
  * @see ShowCompMidlet
  * @version 1.0 02/01/2002
  * @author Kim.W.G
  */
public class ShowCompCanvas extends Canvas {

	/**
	 *  ¸ Ÿ 
	 */
	private static final int MENU = 0;
	private static final int LIST = 1;
	private static final int POPUP = 2;
	private static final int ALERT = 3;
	private static final int CONFIRM = 4;
	
	int state = MENU;					// ʱ ´ menu

	// Declare XSList for intro menu
	XSList xlist = null;
	String menu[] = {"LIST", "POPUP", "ALERT", "CONFIRM"};
	String lists[] = {"ù° ", "ι° ", "° ", "׹° ", "ټ° ", 
						"° ", "ϰ° ", "° ", "ȩ° ", "° ", "ѹ° "};
	String popups[] = {"Popup Menu 1", "Popup Menu 2", "Popup Menu 3", "Popup Menu 4"};
	
	XSList list = null;
	XSList popup = null;
	XSButton ok = null;
	XSButton cancel = null;
	XSDialog confirm = null;
	XSDialog alert = null;

	/**
	 * Ŭ νϽ 
	 */
	public ShowCompCanvas() { 
		// Create XSList instance as list type
		xlist = new XSList(this, menu, XSList.LIST);
		xlist.setTitle("޴ ");
		ok = new XSButton(this, "OK", XSButton.RIGHT);
		cancel = new XSButton(this, "CANCEL", XSButton.LEFT);
		xlist.addRightButton(ok);			// add right button
		xlist.addLeftButton(cancel);		// add left button
	}

	public void keyPressed(int keyCode) {
		if( state == MENU ) {			// menu mode
			switch(keyCode) {
				case KEY_COMR :
					switch(xlist.getCurrentIndex()) {
						case 0 : 
							list = new XSList(this, lists, XSList.LIST);
							list.setTitle("Ʈ");
							state = LIST;
							repaint();
							break;
						case 1 : 
							popup = new XSList(this, popups, XSList.POPUP);
							popup.setTitle("˾..");
							state = POPUP;
							repaint();
							break;
						case 2 : 
							alert = new XSDialog(this, "DIALOG BOX Դϴ.", XSDialog.ALERT);
							state = ALERT;
							repaint();
							break;
						case 3 : 
							confirm = new XSDialog(this, "CONFIRM BOX  Դϴ.  3 ǰ  .", XSDialog.CONFIRM);
							state = CONFIRM;
							repaint();
							break;
						case 4 : break;
					} // end switch
					break;

				case KEY_DOWN :
					xlist.next();
					break;
				case KEY_UP :
					xlist.previous();
					break;
			} // end switch
		} // end if, menu....

		else if( state == LIST ) {		// list mode
			switch(keyCode) {
				case KEY_COMR :
					break;
				case KEY_COML :
					state = MENU;
					repaint();
					break;
				case KEY_DOWN :
					list.next();
					break;
				case KEY_UP :
					list.previous();
					break;
			} // end switch
		} // end if, LIST...

		else if( state == POPUP )	{		// popup mode
			switch(keyCode) {
				case KEY_COMR :
					break;
				case KEY_COML :
					state = MENU;
					repaint();
					break;
				case KEY_DOWN :
					popup.next();
					break;
				case KEY_UP :
					popup.previous();
					break;
			} // end switch
		} // end if, POPUP

		else if( state == ALERT ) {
			switch(keyCode) {
				case KEY_COMR :
					state = MENU;
					repaint();
					break;
			}
		} // end if, ALERT

		else if(state == CONFIRM) {
			switch(keyCode) {
				case KEY_COMR :		// press ok button
					state = MENU;
					repaint();
					break;
				case KEY_COML :		// press cancel button
					state = MENU;
					state = MENU;
					repaint();
					break;
			}
		} // end if, CONFIRM

	}

	public void keyRepeated(int keyCode) {
	}

	public void keyReleased(int keyCode) {
	}
	
	public void paint(Graphics g) {
		switch(state) {
			case MENU :
				xlist.show(g);			// XSList(menu) ش.
				break;
			case LIST : 
				list.show(g);			// XSList(list) ش.
				break;
			case POPUP : 
				popup.show(g);			// XSList(popup) ش.
				break;
			case ALERT :
				alert.show(g);			// XSDialog(alert) ش.
				break;
			case CONFIRM : 
				confirm.show(g);		// XSDialog(confirm) ش.
				break;
		} // end switch
	}
}